"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.paginateGetSavingsPlansCoverage = void 0;
const GetSavingsPlansCoverageCommand_1 = require("../commands/GetSavingsPlansCoverageCommand");
const CostExplorerClient_1 = require("../CostExplorerClient");
const makePagedClientRequest = async (client, input, ...args) => {
    return await client.send(new GetSavingsPlansCoverageCommand_1.GetSavingsPlansCoverageCommand(input), ...args);
};
async function* paginateGetSavingsPlansCoverage(config, input, ...additionalArguments) {
    let token = config.startingToken || undefined;
    let hasNext = true;
    let page;
    while (hasNext) {
        input.NextToken = token;
        input["MaxResults"] = config.pageSize;
        if (config.client instanceof CostExplorerClient_1.CostExplorerClient) {
            page = await makePagedClientRequest(config.client, input, ...additionalArguments);
        }
        else {
            throw new Error("Invalid client, expected CostExplorer | CostExplorerClient");
        }
        yield page;
        const prevToken = token;
        token = page.NextToken;
        hasNext = !!(token && (!config.stopOnSameToken || token !== prevToken));
    }
    return undefined;
}
exports.paginateGetSavingsPlansCoverage = paginateGetSavingsPlansCoverage;
