import { CreateAnomalyMonitorCommand, } from "./commands/CreateAnomalyMonitorCommand";
import { CreateAnomalySubscriptionCommand, } from "./commands/CreateAnomalySubscriptionCommand";
import { CreateCostCategoryDefinitionCommand, } from "./commands/CreateCostCategoryDefinitionCommand";
import { DeleteAnomalyMonitorCommand, } from "./commands/DeleteAnomalyMonitorCommand";
import { DeleteAnomalySubscriptionCommand, } from "./commands/DeleteAnomalySubscriptionCommand";
import { DeleteCostCategoryDefinitionCommand, } from "./commands/DeleteCostCategoryDefinitionCommand";
import { DescribeCostCategoryDefinitionCommand, } from "./commands/DescribeCostCategoryDefinitionCommand";
import { GetAnomaliesCommand, } from "./commands/GetAnomaliesCommand";
import { GetAnomalyMonitorsCommand, } from "./commands/GetAnomalyMonitorsCommand";
import { GetAnomalySubscriptionsCommand, } from "./commands/GetAnomalySubscriptionsCommand";
import { GetCostAndUsageCommand, } from "./commands/GetCostAndUsageCommand";
import { GetCostAndUsageWithResourcesCommand, } from "./commands/GetCostAndUsageWithResourcesCommand";
import { GetCostCategoriesCommand, } from "./commands/GetCostCategoriesCommand";
import { GetCostForecastCommand, } from "./commands/GetCostForecastCommand";
import { GetDimensionValuesCommand, } from "./commands/GetDimensionValuesCommand";
import { GetReservationCoverageCommand, } from "./commands/GetReservationCoverageCommand";
import { GetReservationPurchaseRecommendationCommand, } from "./commands/GetReservationPurchaseRecommendationCommand";
import { GetReservationUtilizationCommand, } from "./commands/GetReservationUtilizationCommand";
import { GetRightsizingRecommendationCommand, } from "./commands/GetRightsizingRecommendationCommand";
import { GetSavingsPlansCoverageCommand, } from "./commands/GetSavingsPlansCoverageCommand";
import { GetSavingsPlansPurchaseRecommendationCommand, } from "./commands/GetSavingsPlansPurchaseRecommendationCommand";
import { GetSavingsPlansUtilizationCommand, } from "./commands/GetSavingsPlansUtilizationCommand";
import { GetSavingsPlansUtilizationDetailsCommand, } from "./commands/GetSavingsPlansUtilizationDetailsCommand";
import { GetTagsCommand } from "./commands/GetTagsCommand";
import { GetUsageForecastCommand, } from "./commands/GetUsageForecastCommand";
import { ListCostAllocationTagsCommand, } from "./commands/ListCostAllocationTagsCommand";
import { ListCostCategoryDefinitionsCommand, } from "./commands/ListCostCategoryDefinitionsCommand";
import { ListSavingsPlansPurchaseRecommendationGenerationCommand, } from "./commands/ListSavingsPlansPurchaseRecommendationGenerationCommand";
import { ListTagsForResourceCommand, } from "./commands/ListTagsForResourceCommand";
import { ProvideAnomalyFeedbackCommand, } from "./commands/ProvideAnomalyFeedbackCommand";
import { StartSavingsPlansPurchaseRecommendationGenerationCommand, } from "./commands/StartSavingsPlansPurchaseRecommendationGenerationCommand";
import { TagResourceCommand } from "./commands/TagResourceCommand";
import { UntagResourceCommand, } from "./commands/UntagResourceCommand";
import { UpdateAnomalyMonitorCommand, } from "./commands/UpdateAnomalyMonitorCommand";
import { UpdateAnomalySubscriptionCommand, } from "./commands/UpdateAnomalySubscriptionCommand";
import { UpdateCostAllocationTagsStatusCommand, } from "./commands/UpdateCostAllocationTagsStatusCommand";
import { UpdateCostCategoryDefinitionCommand, } from "./commands/UpdateCostCategoryDefinitionCommand";
import { CostExplorerClient } from "./CostExplorerClient";
export class CostExplorer extends CostExplorerClient {
    createAnomalyMonitor(args, optionsOrCb, cb) {
        const command = new CreateAnomalyMonitorCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    createAnomalySubscription(args, optionsOrCb, cb) {
        const command = new CreateAnomalySubscriptionCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    createCostCategoryDefinition(args, optionsOrCb, cb) {
        const command = new CreateCostCategoryDefinitionCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    deleteAnomalyMonitor(args, optionsOrCb, cb) {
        const command = new DeleteAnomalyMonitorCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    deleteAnomalySubscription(args, optionsOrCb, cb) {
        const command = new DeleteAnomalySubscriptionCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    deleteCostCategoryDefinition(args, optionsOrCb, cb) {
        const command = new DeleteCostCategoryDefinitionCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    describeCostCategoryDefinition(args, optionsOrCb, cb) {
        const command = new DescribeCostCategoryDefinitionCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    getAnomalies(args, optionsOrCb, cb) {
        const command = new GetAnomaliesCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    getAnomalyMonitors(args, optionsOrCb, cb) {
        const command = new GetAnomalyMonitorsCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    getAnomalySubscriptions(args, optionsOrCb, cb) {
        const command = new GetAnomalySubscriptionsCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    getCostAndUsage(args, optionsOrCb, cb) {
        const command = new GetCostAndUsageCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    getCostAndUsageWithResources(args, optionsOrCb, cb) {
        const command = new GetCostAndUsageWithResourcesCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    getCostCategories(args, optionsOrCb, cb) {
        const command = new GetCostCategoriesCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    getCostForecast(args, optionsOrCb, cb) {
        const command = new GetCostForecastCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    getDimensionValues(args, optionsOrCb, cb) {
        const command = new GetDimensionValuesCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    getReservationCoverage(args, optionsOrCb, cb) {
        const command = new GetReservationCoverageCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    getReservationPurchaseRecommendation(args, optionsOrCb, cb) {
        const command = new GetReservationPurchaseRecommendationCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    getReservationUtilization(args, optionsOrCb, cb) {
        const command = new GetReservationUtilizationCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    getRightsizingRecommendation(args, optionsOrCb, cb) {
        const command = new GetRightsizingRecommendationCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    getSavingsPlansCoverage(args, optionsOrCb, cb) {
        const command = new GetSavingsPlansCoverageCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    getSavingsPlansPurchaseRecommendation(args, optionsOrCb, cb) {
        const command = new GetSavingsPlansPurchaseRecommendationCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    getSavingsPlansUtilization(args, optionsOrCb, cb) {
        const command = new GetSavingsPlansUtilizationCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    getSavingsPlansUtilizationDetails(args, optionsOrCb, cb) {
        const command = new GetSavingsPlansUtilizationDetailsCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    getTags(args, optionsOrCb, cb) {
        const command = new GetTagsCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    getUsageForecast(args, optionsOrCb, cb) {
        const command = new GetUsageForecastCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    listCostAllocationTags(args, optionsOrCb, cb) {
        const command = new ListCostAllocationTagsCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    listCostCategoryDefinitions(args, optionsOrCb, cb) {
        const command = new ListCostCategoryDefinitionsCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    listSavingsPlansPurchaseRecommendationGeneration(args, optionsOrCb, cb) {
        const command = new ListSavingsPlansPurchaseRecommendationGenerationCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    listTagsForResource(args, optionsOrCb, cb) {
        const command = new ListTagsForResourceCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    provideAnomalyFeedback(args, optionsOrCb, cb) {
        const command = new ProvideAnomalyFeedbackCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    startSavingsPlansPurchaseRecommendationGeneration(args, optionsOrCb, cb) {
        const command = new StartSavingsPlansPurchaseRecommendationGenerationCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    tagResource(args, optionsOrCb, cb) {
        const command = new TagResourceCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    untagResource(args, optionsOrCb, cb) {
        const command = new UntagResourceCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    updateAnomalyMonitor(args, optionsOrCb, cb) {
        const command = new UpdateAnomalyMonitorCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    updateAnomalySubscription(args, optionsOrCb, cb) {
        const command = new UpdateAnomalySubscriptionCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    updateCostAllocationTagsStatus(args, optionsOrCb, cb) {
        const command = new UpdateCostAllocationTagsStatusCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
    updateCostCategoryDefinition(args, optionsOrCb, cb) {
        const command = new UpdateCostCategoryDefinitionCommand(args);
        if (typeof optionsOrCb === "function") {
            this.send(command, optionsOrCb);
        }
        else if (typeof cb === "function") {
            if (typeof optionsOrCb !== "object")
                throw new Error(`Expect http options but get ${typeof optionsOrCb}`);
            this.send(command, optionsOrCb || {}, cb);
        }
        else {
            return this.send(command, optionsOrCb);
        }
    }
}
