import { HttpRequest as __HttpRequest } from "@aws-sdk/protocol-http";
import { decorateServiceException as __decorateServiceException, expectBoolean as __expectBoolean, expectInt32 as __expectInt32, expectString as __expectString, limitedParseDouble as __limitedParseDouble, serializeFloat as __serializeFloat, throwDefaultError, } from "@aws-sdk/smithy-client";
import { CostExplorerServiceException as __BaseException } from "../models/CostExplorerServiceException";
import { BillExpirationException, DataUnavailableException, GenerationExistsException, InvalidNextTokenException, LimitExceededException, RequestChangedException, ResourceNotFoundException, ServiceQuotaExceededException, TooManyTagsException, UnknownMonitorException, UnknownSubscriptionException, UnresolvableUsageUnitException, } from "../models/models_0";
export const serializeAws_json1_1CreateAnomalyMonitorCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.CreateAnomalyMonitor",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1CreateAnomalyMonitorRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1CreateAnomalySubscriptionCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.CreateAnomalySubscription",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1CreateAnomalySubscriptionRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1CreateCostCategoryDefinitionCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.CreateCostCategoryDefinition",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1CreateCostCategoryDefinitionRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1DeleteAnomalyMonitorCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.DeleteAnomalyMonitor",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1DeleteAnomalyMonitorRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1DeleteAnomalySubscriptionCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.DeleteAnomalySubscription",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1DeleteAnomalySubscriptionRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1DeleteCostCategoryDefinitionCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.DeleteCostCategoryDefinition",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1DeleteCostCategoryDefinitionRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1DescribeCostCategoryDefinitionCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.DescribeCostCategoryDefinition",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1DescribeCostCategoryDefinitionRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1GetAnomaliesCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetAnomalies",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1GetAnomaliesRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1GetAnomalyMonitorsCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetAnomalyMonitors",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1GetAnomalyMonitorsRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1GetAnomalySubscriptionsCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetAnomalySubscriptions",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1GetAnomalySubscriptionsRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1GetCostAndUsageCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetCostAndUsage",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1GetCostAndUsageRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1GetCostAndUsageWithResourcesCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetCostAndUsageWithResources",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1GetCostAndUsageWithResourcesRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1GetCostCategoriesCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetCostCategories",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1GetCostCategoriesRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1GetCostForecastCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetCostForecast",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1GetCostForecastRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1GetDimensionValuesCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetDimensionValues",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1GetDimensionValuesRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1GetReservationCoverageCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetReservationCoverage",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1GetReservationCoverageRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1GetReservationPurchaseRecommendationCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetReservationPurchaseRecommendation",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1GetReservationPurchaseRecommendationRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1GetReservationUtilizationCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetReservationUtilization",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1GetReservationUtilizationRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1GetRightsizingRecommendationCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetRightsizingRecommendation",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1GetRightsizingRecommendationRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1GetSavingsPlansCoverageCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetSavingsPlansCoverage",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1GetSavingsPlansCoverageRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1GetSavingsPlansPurchaseRecommendationCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetSavingsPlansPurchaseRecommendation",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1GetSavingsPlansPurchaseRecommendationRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1GetSavingsPlansUtilizationCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetSavingsPlansUtilization",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1GetSavingsPlansUtilizationRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1GetSavingsPlansUtilizationDetailsCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetSavingsPlansUtilizationDetails",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1GetSavingsPlansUtilizationDetailsRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1GetTagsCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetTags",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1GetTagsRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1GetUsageForecastCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.GetUsageForecast",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1GetUsageForecastRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1ListCostAllocationTagsCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.ListCostAllocationTags",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1ListCostAllocationTagsRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1ListCostCategoryDefinitionsCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.ListCostCategoryDefinitions",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1ListCostCategoryDefinitionsRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1ListSavingsPlansPurchaseRecommendationGenerationCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.ListSavingsPlansPurchaseRecommendationGeneration",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1ListSavingsPlansPurchaseRecommendationGenerationRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1ListTagsForResourceCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.ListTagsForResource",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1ListTagsForResourceRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1ProvideAnomalyFeedbackCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.ProvideAnomalyFeedback",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1ProvideAnomalyFeedbackRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1StartSavingsPlansPurchaseRecommendationGenerationCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.StartSavingsPlansPurchaseRecommendationGeneration",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1StartSavingsPlansPurchaseRecommendationGenerationRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1TagResourceCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.TagResource",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1TagResourceRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1UntagResourceCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.UntagResource",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1UntagResourceRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1UpdateAnomalyMonitorCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.UpdateAnomalyMonitor",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1UpdateAnomalyMonitorRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1UpdateAnomalySubscriptionCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.UpdateAnomalySubscription",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1UpdateAnomalySubscriptionRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1UpdateCostAllocationTagsStatusCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.UpdateCostAllocationTagsStatus",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1UpdateCostAllocationTagsStatusRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1UpdateCostCategoryDefinitionCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "AWSInsightsIndexService.UpdateCostCategoryDefinition",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1UpdateCostCategoryDefinitionRequest(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const deserializeAws_json1_1CreateAnomalyMonitorCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1CreateAnomalyMonitorCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1CreateAnomalyMonitorResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1CreateAnomalyMonitorCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1CreateAnomalySubscriptionCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1CreateAnomalySubscriptionCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1CreateAnomalySubscriptionResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1CreateAnomalySubscriptionCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        case "UnknownMonitorException":
        case "com.amazonaws.costexplorer#UnknownMonitorException":
            throw await deserializeAws_json1_1UnknownMonitorExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1CreateCostCategoryDefinitionCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1CreateCostCategoryDefinitionCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1CreateCostCategoryDefinitionResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1CreateCostCategoryDefinitionCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.costexplorer#ServiceQuotaExceededException":
            throw await deserializeAws_json1_1ServiceQuotaExceededExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1DeleteAnomalyMonitorCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1DeleteAnomalyMonitorCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1DeleteAnomalyMonitorResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1DeleteAnomalyMonitorCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        case "UnknownMonitorException":
        case "com.amazonaws.costexplorer#UnknownMonitorException":
            throw await deserializeAws_json1_1UnknownMonitorExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1DeleteAnomalySubscriptionCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1DeleteAnomalySubscriptionCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1DeleteAnomalySubscriptionResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1DeleteAnomalySubscriptionCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        case "UnknownSubscriptionException":
        case "com.amazonaws.costexplorer#UnknownSubscriptionException":
            throw await deserializeAws_json1_1UnknownSubscriptionExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1DeleteCostCategoryDefinitionCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1DeleteCostCategoryDefinitionCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1DeleteCostCategoryDefinitionResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1DeleteCostCategoryDefinitionCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.costexplorer#ResourceNotFoundException":
            throw await deserializeAws_json1_1ResourceNotFoundExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1DescribeCostCategoryDefinitionCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1DescribeCostCategoryDefinitionCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1DescribeCostCategoryDefinitionResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1DescribeCostCategoryDefinitionCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.costexplorer#ResourceNotFoundException":
            throw await deserializeAws_json1_1ResourceNotFoundExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1GetAnomaliesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1GetAnomaliesCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1GetAnomaliesResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1GetAnomaliesCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await deserializeAws_json1_1InvalidNextTokenExceptionResponse(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1GetAnomalyMonitorsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1GetAnomalyMonitorsCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1GetAnomalyMonitorsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1GetAnomalyMonitorsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await deserializeAws_json1_1InvalidNextTokenExceptionResponse(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        case "UnknownMonitorException":
        case "com.amazonaws.costexplorer#UnknownMonitorException":
            throw await deserializeAws_json1_1UnknownMonitorExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1GetAnomalySubscriptionsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1GetAnomalySubscriptionsCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1GetAnomalySubscriptionsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1GetAnomalySubscriptionsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await deserializeAws_json1_1InvalidNextTokenExceptionResponse(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        case "UnknownSubscriptionException":
        case "com.amazonaws.costexplorer#UnknownSubscriptionException":
            throw await deserializeAws_json1_1UnknownSubscriptionExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1GetCostAndUsageCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1GetCostAndUsageCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1GetCostAndUsageResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1GetCostAndUsageCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BillExpirationException":
        case "com.amazonaws.costexplorer#BillExpirationException":
            throw await deserializeAws_json1_1BillExpirationExceptionResponse(parsedOutput, context);
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await deserializeAws_json1_1DataUnavailableExceptionResponse(parsedOutput, context);
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await deserializeAws_json1_1InvalidNextTokenExceptionResponse(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        case "RequestChangedException":
        case "com.amazonaws.costexplorer#RequestChangedException":
            throw await deserializeAws_json1_1RequestChangedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1GetCostAndUsageWithResourcesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1GetCostAndUsageWithResourcesCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1GetCostAndUsageWithResourcesResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1GetCostAndUsageWithResourcesCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BillExpirationException":
        case "com.amazonaws.costexplorer#BillExpirationException":
            throw await deserializeAws_json1_1BillExpirationExceptionResponse(parsedOutput, context);
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await deserializeAws_json1_1DataUnavailableExceptionResponse(parsedOutput, context);
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await deserializeAws_json1_1InvalidNextTokenExceptionResponse(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        case "RequestChangedException":
        case "com.amazonaws.costexplorer#RequestChangedException":
            throw await deserializeAws_json1_1RequestChangedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1GetCostCategoriesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1GetCostCategoriesCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1GetCostCategoriesResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1GetCostCategoriesCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BillExpirationException":
        case "com.amazonaws.costexplorer#BillExpirationException":
            throw await deserializeAws_json1_1BillExpirationExceptionResponse(parsedOutput, context);
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await deserializeAws_json1_1DataUnavailableExceptionResponse(parsedOutput, context);
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await deserializeAws_json1_1InvalidNextTokenExceptionResponse(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        case "RequestChangedException":
        case "com.amazonaws.costexplorer#RequestChangedException":
            throw await deserializeAws_json1_1RequestChangedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1GetCostForecastCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1GetCostForecastCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1GetCostForecastResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1GetCostForecastCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await deserializeAws_json1_1DataUnavailableExceptionResponse(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1GetDimensionValuesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1GetDimensionValuesCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1GetDimensionValuesResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1GetDimensionValuesCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BillExpirationException":
        case "com.amazonaws.costexplorer#BillExpirationException":
            throw await deserializeAws_json1_1BillExpirationExceptionResponse(parsedOutput, context);
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await deserializeAws_json1_1DataUnavailableExceptionResponse(parsedOutput, context);
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await deserializeAws_json1_1InvalidNextTokenExceptionResponse(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        case "RequestChangedException":
        case "com.amazonaws.costexplorer#RequestChangedException":
            throw await deserializeAws_json1_1RequestChangedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1GetReservationCoverageCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1GetReservationCoverageCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1GetReservationCoverageResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1GetReservationCoverageCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await deserializeAws_json1_1DataUnavailableExceptionResponse(parsedOutput, context);
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await deserializeAws_json1_1InvalidNextTokenExceptionResponse(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1GetReservationPurchaseRecommendationCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1GetReservationPurchaseRecommendationCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1GetReservationPurchaseRecommendationResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1GetReservationPurchaseRecommendationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await deserializeAws_json1_1DataUnavailableExceptionResponse(parsedOutput, context);
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await deserializeAws_json1_1InvalidNextTokenExceptionResponse(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1GetReservationUtilizationCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1GetReservationUtilizationCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1GetReservationUtilizationResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1GetReservationUtilizationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await deserializeAws_json1_1DataUnavailableExceptionResponse(parsedOutput, context);
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await deserializeAws_json1_1InvalidNextTokenExceptionResponse(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1GetRightsizingRecommendationCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1GetRightsizingRecommendationCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1GetRightsizingRecommendationResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1GetRightsizingRecommendationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await deserializeAws_json1_1InvalidNextTokenExceptionResponse(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1GetSavingsPlansCoverageCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1GetSavingsPlansCoverageCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1GetSavingsPlansCoverageResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1GetSavingsPlansCoverageCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await deserializeAws_json1_1DataUnavailableExceptionResponse(parsedOutput, context);
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await deserializeAws_json1_1InvalidNextTokenExceptionResponse(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1GetSavingsPlansPurchaseRecommendationCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1GetSavingsPlansPurchaseRecommendationCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1GetSavingsPlansPurchaseRecommendationResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1GetSavingsPlansPurchaseRecommendationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await deserializeAws_json1_1InvalidNextTokenExceptionResponse(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1GetSavingsPlansUtilizationCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1GetSavingsPlansUtilizationCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1GetSavingsPlansUtilizationResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1GetSavingsPlansUtilizationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await deserializeAws_json1_1DataUnavailableExceptionResponse(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1GetSavingsPlansUtilizationDetailsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1GetSavingsPlansUtilizationDetailsCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1GetSavingsPlansUtilizationDetailsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1GetSavingsPlansUtilizationDetailsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await deserializeAws_json1_1DataUnavailableExceptionResponse(parsedOutput, context);
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await deserializeAws_json1_1InvalidNextTokenExceptionResponse(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1GetTagsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1GetTagsCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1GetTagsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1GetTagsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "BillExpirationException":
        case "com.amazonaws.costexplorer#BillExpirationException":
            throw await deserializeAws_json1_1BillExpirationExceptionResponse(parsedOutput, context);
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await deserializeAws_json1_1DataUnavailableExceptionResponse(parsedOutput, context);
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await deserializeAws_json1_1InvalidNextTokenExceptionResponse(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        case "RequestChangedException":
        case "com.amazonaws.costexplorer#RequestChangedException":
            throw await deserializeAws_json1_1RequestChangedExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1GetUsageForecastCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1GetUsageForecastCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1GetUsageForecastResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1GetUsageForecastCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "DataUnavailableException":
        case "com.amazonaws.costexplorer#DataUnavailableException":
            throw await deserializeAws_json1_1DataUnavailableExceptionResponse(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        case "UnresolvableUsageUnitException":
        case "com.amazonaws.costexplorer#UnresolvableUsageUnitException":
            throw await deserializeAws_json1_1UnresolvableUsageUnitExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1ListCostAllocationTagsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1ListCostAllocationTagsCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1ListCostAllocationTagsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1ListCostAllocationTagsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await deserializeAws_json1_1InvalidNextTokenExceptionResponse(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1ListCostCategoryDefinitionsCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1ListCostCategoryDefinitionsCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1ListCostCategoryDefinitionsResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1ListCostCategoryDefinitionsCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1ListSavingsPlansPurchaseRecommendationGenerationCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1ListSavingsPlansPurchaseRecommendationGenerationCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1ListSavingsPlansPurchaseRecommendationGenerationResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1ListSavingsPlansPurchaseRecommendationGenerationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InvalidNextTokenException":
        case "com.amazonaws.costexplorer#InvalidNextTokenException":
            throw await deserializeAws_json1_1InvalidNextTokenExceptionResponse(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1ListTagsForResourceCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1ListTagsForResourceCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1ListTagsForResourceResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1ListTagsForResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.costexplorer#ResourceNotFoundException":
            throw await deserializeAws_json1_1ResourceNotFoundExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1ProvideAnomalyFeedbackCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1ProvideAnomalyFeedbackCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1ProvideAnomalyFeedbackResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1ProvideAnomalyFeedbackCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1StartSavingsPlansPurchaseRecommendationGenerationCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1StartSavingsPlansPurchaseRecommendationGenerationCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1StartSavingsPlansPurchaseRecommendationGenerationResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1StartSavingsPlansPurchaseRecommendationGenerationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "GenerationExistsException":
        case "com.amazonaws.costexplorer#GenerationExistsException":
            throw await deserializeAws_json1_1GenerationExistsExceptionResponse(parsedOutput, context);
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.costexplorer#ServiceQuotaExceededException":
            throw await deserializeAws_json1_1ServiceQuotaExceededExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1TagResourceCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1TagResourceCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1TagResourceResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1TagResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.costexplorer#ResourceNotFoundException":
            throw await deserializeAws_json1_1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "TooManyTagsException":
        case "com.amazonaws.costexplorer#TooManyTagsException":
            throw await deserializeAws_json1_1TooManyTagsExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1UntagResourceCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1UntagResourceCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1UntagResourceResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1UntagResourceCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.costexplorer#ResourceNotFoundException":
            throw await deserializeAws_json1_1ResourceNotFoundExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1UpdateAnomalyMonitorCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1UpdateAnomalyMonitorCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1UpdateAnomalyMonitorResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1UpdateAnomalyMonitorCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        case "UnknownMonitorException":
        case "com.amazonaws.costexplorer#UnknownMonitorException":
            throw await deserializeAws_json1_1UnknownMonitorExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1UpdateAnomalySubscriptionCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1UpdateAnomalySubscriptionCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1UpdateAnomalySubscriptionResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1UpdateAnomalySubscriptionCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        case "UnknownMonitorException":
        case "com.amazonaws.costexplorer#UnknownMonitorException":
            throw await deserializeAws_json1_1UnknownMonitorExceptionResponse(parsedOutput, context);
        case "UnknownSubscriptionException":
        case "com.amazonaws.costexplorer#UnknownSubscriptionException":
            throw await deserializeAws_json1_1UnknownSubscriptionExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1UpdateCostAllocationTagsStatusCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1UpdateCostAllocationTagsStatusCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1UpdateCostAllocationTagsStatusResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1UpdateCostAllocationTagsStatusCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1UpdateCostCategoryDefinitionCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1UpdateCostCategoryDefinitionCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1UpdateCostCategoryDefinitionResponse(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1UpdateCostCategoryDefinitionCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseErrorBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "LimitExceededException":
        case "com.amazonaws.costexplorer#LimitExceededException":
            throw await deserializeAws_json1_1LimitExceededExceptionResponse(parsedOutput, context);
        case "ResourceNotFoundException":
        case "com.amazonaws.costexplorer#ResourceNotFoundException":
            throw await deserializeAws_json1_1ResourceNotFoundExceptionResponse(parsedOutput, context);
        case "ServiceQuotaExceededException":
        case "com.amazonaws.costexplorer#ServiceQuotaExceededException":
            throw await deserializeAws_json1_1ServiceQuotaExceededExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
const deserializeAws_json1_1BillExpirationExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1BillExpirationException(body, context);
    const exception = new BillExpirationException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const deserializeAws_json1_1DataUnavailableExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1DataUnavailableException(body, context);
    const exception = new DataUnavailableException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const deserializeAws_json1_1GenerationExistsExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1GenerationExistsException(body, context);
    const exception = new GenerationExistsException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const deserializeAws_json1_1InvalidNextTokenExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1InvalidNextTokenException(body, context);
    const exception = new InvalidNextTokenException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const deserializeAws_json1_1LimitExceededExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1LimitExceededException(body, context);
    const exception = new LimitExceededException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const deserializeAws_json1_1RequestChangedExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1RequestChangedException(body, context);
    const exception = new RequestChangedException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const deserializeAws_json1_1ResourceNotFoundExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1ResourceNotFoundException(body, context);
    const exception = new ResourceNotFoundException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const deserializeAws_json1_1ServiceQuotaExceededExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1ServiceQuotaExceededException(body, context);
    const exception = new ServiceQuotaExceededException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const deserializeAws_json1_1TooManyTagsExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1TooManyTagsException(body, context);
    const exception = new TooManyTagsException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const deserializeAws_json1_1UnknownMonitorExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1UnknownMonitorException(body, context);
    const exception = new UnknownMonitorException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const deserializeAws_json1_1UnknownSubscriptionExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1UnknownSubscriptionException(body, context);
    const exception = new UnknownSubscriptionException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const deserializeAws_json1_1UnresolvableUsageUnitExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1UnresolvableUsageUnitException(body, context);
    const exception = new UnresolvableUsageUnitException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const serializeAws_json1_1AnomalyDateInterval = (input, context) => {
    return {
        ...(input.EndDate != null && { EndDate: input.EndDate }),
        ...(input.StartDate != null && { StartDate: input.StartDate }),
    };
};
const serializeAws_json1_1AnomalyMonitor = (input, context) => {
    return {
        ...(input.CreationDate != null && { CreationDate: input.CreationDate }),
        ...(input.DimensionalValueCount != null && { DimensionalValueCount: input.DimensionalValueCount }),
        ...(input.LastEvaluatedDate != null && { LastEvaluatedDate: input.LastEvaluatedDate }),
        ...(input.LastUpdatedDate != null && { LastUpdatedDate: input.LastUpdatedDate }),
        ...(input.MonitorArn != null && { MonitorArn: input.MonitorArn }),
        ...(input.MonitorDimension != null && { MonitorDimension: input.MonitorDimension }),
        ...(input.MonitorName != null && { MonitorName: input.MonitorName }),
        ...(input.MonitorSpecification != null && {
            MonitorSpecification: serializeAws_json1_1Expression(input.MonitorSpecification, context),
        }),
        ...(input.MonitorType != null && { MonitorType: input.MonitorType }),
    };
};
const serializeAws_json1_1AnomalySubscription = (input, context) => {
    return {
        ...(input.AccountId != null && { AccountId: input.AccountId }),
        ...(input.Frequency != null && { Frequency: input.Frequency }),
        ...(input.MonitorArnList != null && {
            MonitorArnList: serializeAws_json1_1MonitorArnList(input.MonitorArnList, context),
        }),
        ...(input.Subscribers != null && { Subscribers: serializeAws_json1_1Subscribers(input.Subscribers, context) }),
        ...(input.SubscriptionArn != null && { SubscriptionArn: input.SubscriptionArn }),
        ...(input.SubscriptionName != null && { SubscriptionName: input.SubscriptionName }),
        ...(input.Threshold != null && { Threshold: __serializeFloat(input.Threshold) }),
        ...(input.ThresholdExpression != null && {
            ThresholdExpression: serializeAws_json1_1Expression(input.ThresholdExpression, context),
        }),
    };
};
const serializeAws_json1_1CostAllocationTagKeyList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const serializeAws_json1_1CostAllocationTagStatusEntry = (input, context) => {
    return {
        ...(input.Status != null && { Status: input.Status }),
        ...(input.TagKey != null && { TagKey: input.TagKey }),
    };
};
const serializeAws_json1_1CostAllocationTagStatusList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return serializeAws_json1_1CostAllocationTagStatusEntry(entry, context);
    });
};
const serializeAws_json1_1CostCategoryInheritedValueDimension = (input, context) => {
    return {
        ...(input.DimensionKey != null && { DimensionKey: input.DimensionKey }),
        ...(input.DimensionName != null && { DimensionName: input.DimensionName }),
    };
};
const serializeAws_json1_1CostCategoryRule = (input, context) => {
    return {
        ...(input.InheritedValue != null && {
            InheritedValue: serializeAws_json1_1CostCategoryInheritedValueDimension(input.InheritedValue, context),
        }),
        ...(input.Rule != null && { Rule: serializeAws_json1_1Expression(input.Rule, context) }),
        ...(input.Type != null && { Type: input.Type }),
        ...(input.Value != null && { Value: input.Value }),
    };
};
const serializeAws_json1_1CostCategoryRulesList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return serializeAws_json1_1CostCategoryRule(entry, context);
    });
};
const serializeAws_json1_1CostCategorySplitChargeRule = (input, context) => {
    return {
        ...(input.Method != null && { Method: input.Method }),
        ...(input.Parameters != null && {
            Parameters: serializeAws_json1_1CostCategorySplitChargeRuleParametersList(input.Parameters, context),
        }),
        ...(input.Source != null && { Source: input.Source }),
        ...(input.Targets != null && {
            Targets: serializeAws_json1_1CostCategorySplitChargeRuleTargetsList(input.Targets, context),
        }),
    };
};
const serializeAws_json1_1CostCategorySplitChargeRuleParameter = (input, context) => {
    return {
        ...(input.Type != null && { Type: input.Type }),
        ...(input.Values != null && {
            Values: serializeAws_json1_1CostCategorySplitChargeRuleParameterValuesList(input.Values, context),
        }),
    };
};
const serializeAws_json1_1CostCategorySplitChargeRuleParametersList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return serializeAws_json1_1CostCategorySplitChargeRuleParameter(entry, context);
    });
};
const serializeAws_json1_1CostCategorySplitChargeRuleParameterValuesList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const serializeAws_json1_1CostCategorySplitChargeRulesList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return serializeAws_json1_1CostCategorySplitChargeRule(entry, context);
    });
};
const serializeAws_json1_1CostCategorySplitChargeRuleTargetsList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const serializeAws_json1_1CostCategoryValues = (input, context) => {
    return {
        ...(input.Key != null && { Key: input.Key }),
        ...(input.MatchOptions != null && { MatchOptions: serializeAws_json1_1MatchOptions(input.MatchOptions, context) }),
        ...(input.Values != null && { Values: serializeAws_json1_1Values(input.Values, context) }),
    };
};
const serializeAws_json1_1CreateAnomalyMonitorRequest = (input, context) => {
    return {
        ...(input.AnomalyMonitor != null && {
            AnomalyMonitor: serializeAws_json1_1AnomalyMonitor(input.AnomalyMonitor, context),
        }),
        ...(input.ResourceTags != null && {
            ResourceTags: serializeAws_json1_1ResourceTagList(input.ResourceTags, context),
        }),
    };
};
const serializeAws_json1_1CreateAnomalySubscriptionRequest = (input, context) => {
    return {
        ...(input.AnomalySubscription != null && {
            AnomalySubscription: serializeAws_json1_1AnomalySubscription(input.AnomalySubscription, context),
        }),
        ...(input.ResourceTags != null && {
            ResourceTags: serializeAws_json1_1ResourceTagList(input.ResourceTags, context),
        }),
    };
};
const serializeAws_json1_1CreateCostCategoryDefinitionRequest = (input, context) => {
    return {
        ...(input.DefaultValue != null && { DefaultValue: input.DefaultValue }),
        ...(input.EffectiveStart != null && { EffectiveStart: input.EffectiveStart }),
        ...(input.Name != null && { Name: input.Name }),
        ...(input.ResourceTags != null && {
            ResourceTags: serializeAws_json1_1ResourceTagList(input.ResourceTags, context),
        }),
        ...(input.RuleVersion != null && { RuleVersion: input.RuleVersion }),
        ...(input.Rules != null && { Rules: serializeAws_json1_1CostCategoryRulesList(input.Rules, context) }),
        ...(input.SplitChargeRules != null && {
            SplitChargeRules: serializeAws_json1_1CostCategorySplitChargeRulesList(input.SplitChargeRules, context),
        }),
    };
};
const serializeAws_json1_1DateInterval = (input, context) => {
    return {
        ...(input.End != null && { End: input.End }),
        ...(input.Start != null && { Start: input.Start }),
    };
};
const serializeAws_json1_1DeleteAnomalyMonitorRequest = (input, context) => {
    return {
        ...(input.MonitorArn != null && { MonitorArn: input.MonitorArn }),
    };
};
const serializeAws_json1_1DeleteAnomalySubscriptionRequest = (input, context) => {
    return {
        ...(input.SubscriptionArn != null && { SubscriptionArn: input.SubscriptionArn }),
    };
};
const serializeAws_json1_1DeleteCostCategoryDefinitionRequest = (input, context) => {
    return {
        ...(input.CostCategoryArn != null && { CostCategoryArn: input.CostCategoryArn }),
    };
};
const serializeAws_json1_1DescribeCostCategoryDefinitionRequest = (input, context) => {
    return {
        ...(input.CostCategoryArn != null && { CostCategoryArn: input.CostCategoryArn }),
        ...(input.EffectiveOn != null && { EffectiveOn: input.EffectiveOn }),
    };
};
const serializeAws_json1_1DimensionValues = (input, context) => {
    return {
        ...(input.Key != null && { Key: input.Key }),
        ...(input.MatchOptions != null && { MatchOptions: serializeAws_json1_1MatchOptions(input.MatchOptions, context) }),
        ...(input.Values != null && { Values: serializeAws_json1_1Values(input.Values, context) }),
    };
};
const serializeAws_json1_1EC2Specification = (input, context) => {
    return {
        ...(input.OfferingClass != null && { OfferingClass: input.OfferingClass }),
    };
};
const serializeAws_json1_1Expression = (input, context) => {
    return {
        ...(input.And != null && { And: serializeAws_json1_1Expressions(input.And, context) }),
        ...(input.CostCategories != null && {
            CostCategories: serializeAws_json1_1CostCategoryValues(input.CostCategories, context),
        }),
        ...(input.Dimensions != null && { Dimensions: serializeAws_json1_1DimensionValues(input.Dimensions, context) }),
        ...(input.Not != null && { Not: serializeAws_json1_1Expression(input.Not, context) }),
        ...(input.Or != null && { Or: serializeAws_json1_1Expressions(input.Or, context) }),
        ...(input.Tags != null && { Tags: serializeAws_json1_1TagValues(input.Tags, context) }),
    };
};
const serializeAws_json1_1Expressions = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return serializeAws_json1_1Expression(entry, context);
    });
};
const serializeAws_json1_1GetAnomaliesRequest = (input, context) => {
    return {
        ...(input.DateInterval != null && {
            DateInterval: serializeAws_json1_1AnomalyDateInterval(input.DateInterval, context),
        }),
        ...(input.Feedback != null && { Feedback: input.Feedback }),
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.MonitorArn != null && { MonitorArn: input.MonitorArn }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.TotalImpact != null && {
            TotalImpact: serializeAws_json1_1TotalImpactFilter(input.TotalImpact, context),
        }),
    };
};
const serializeAws_json1_1GetAnomalyMonitorsRequest = (input, context) => {
    return {
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.MonitorArnList != null && { MonitorArnList: serializeAws_json1_1Values(input.MonitorArnList, context) }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
    };
};
const serializeAws_json1_1GetAnomalySubscriptionsRequest = (input, context) => {
    return {
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.MonitorArn != null && { MonitorArn: input.MonitorArn }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.SubscriptionArnList != null && {
            SubscriptionArnList: serializeAws_json1_1Values(input.SubscriptionArnList, context),
        }),
    };
};
const serializeAws_json1_1GetCostAndUsageRequest = (input, context) => {
    return {
        ...(input.Filter != null && { Filter: serializeAws_json1_1Expression(input.Filter, context) }),
        ...(input.Granularity != null && { Granularity: input.Granularity }),
        ...(input.GroupBy != null && { GroupBy: serializeAws_json1_1GroupDefinitions(input.GroupBy, context) }),
        ...(input.Metrics != null && { Metrics: serializeAws_json1_1MetricNames(input.Metrics, context) }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.TimePeriod != null && { TimePeriod: serializeAws_json1_1DateInterval(input.TimePeriod, context) }),
    };
};
const serializeAws_json1_1GetCostAndUsageWithResourcesRequest = (input, context) => {
    return {
        ...(input.Filter != null && { Filter: serializeAws_json1_1Expression(input.Filter, context) }),
        ...(input.Granularity != null && { Granularity: input.Granularity }),
        ...(input.GroupBy != null && { GroupBy: serializeAws_json1_1GroupDefinitions(input.GroupBy, context) }),
        ...(input.Metrics != null && { Metrics: serializeAws_json1_1MetricNames(input.Metrics, context) }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.TimePeriod != null && { TimePeriod: serializeAws_json1_1DateInterval(input.TimePeriod, context) }),
    };
};
const serializeAws_json1_1GetCostCategoriesRequest = (input, context) => {
    return {
        ...(input.CostCategoryName != null && { CostCategoryName: input.CostCategoryName }),
        ...(input.Filter != null && { Filter: serializeAws_json1_1Expression(input.Filter, context) }),
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.SearchString != null && { SearchString: input.SearchString }),
        ...(input.SortBy != null && { SortBy: serializeAws_json1_1SortDefinitions(input.SortBy, context) }),
        ...(input.TimePeriod != null && { TimePeriod: serializeAws_json1_1DateInterval(input.TimePeriod, context) }),
    };
};
const serializeAws_json1_1GetCostForecastRequest = (input, context) => {
    return {
        ...(input.Filter != null && { Filter: serializeAws_json1_1Expression(input.Filter, context) }),
        ...(input.Granularity != null && { Granularity: input.Granularity }),
        ...(input.Metric != null && { Metric: input.Metric }),
        ...(input.PredictionIntervalLevel != null && { PredictionIntervalLevel: input.PredictionIntervalLevel }),
        ...(input.TimePeriod != null && { TimePeriod: serializeAws_json1_1DateInterval(input.TimePeriod, context) }),
    };
};
const serializeAws_json1_1GetDimensionValuesRequest = (input, context) => {
    return {
        ...(input.Context != null && { Context: input.Context }),
        ...(input.Dimension != null && { Dimension: input.Dimension }),
        ...(input.Filter != null && { Filter: serializeAws_json1_1Expression(input.Filter, context) }),
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.SearchString != null && { SearchString: input.SearchString }),
        ...(input.SortBy != null && { SortBy: serializeAws_json1_1SortDefinitions(input.SortBy, context) }),
        ...(input.TimePeriod != null && { TimePeriod: serializeAws_json1_1DateInterval(input.TimePeriod, context) }),
    };
};
const serializeAws_json1_1GetReservationCoverageRequest = (input, context) => {
    return {
        ...(input.Filter != null && { Filter: serializeAws_json1_1Expression(input.Filter, context) }),
        ...(input.Granularity != null && { Granularity: input.Granularity }),
        ...(input.GroupBy != null && { GroupBy: serializeAws_json1_1GroupDefinitions(input.GroupBy, context) }),
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.Metrics != null && { Metrics: serializeAws_json1_1MetricNames(input.Metrics, context) }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.SortBy != null && { SortBy: serializeAws_json1_1SortDefinition(input.SortBy, context) }),
        ...(input.TimePeriod != null && { TimePeriod: serializeAws_json1_1DateInterval(input.TimePeriod, context) }),
    };
};
const serializeAws_json1_1GetReservationPurchaseRecommendationRequest = (input, context) => {
    return {
        ...(input.AccountId != null && { AccountId: input.AccountId }),
        ...(input.AccountScope != null && { AccountScope: input.AccountScope }),
        ...(input.Filter != null && { Filter: serializeAws_json1_1Expression(input.Filter, context) }),
        ...(input.LookbackPeriodInDays != null && { LookbackPeriodInDays: input.LookbackPeriodInDays }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.PageSize != null && { PageSize: input.PageSize }),
        ...(input.PaymentOption != null && { PaymentOption: input.PaymentOption }),
        ...(input.Service != null && { Service: input.Service }),
        ...(input.ServiceSpecification != null && {
            ServiceSpecification: serializeAws_json1_1ServiceSpecification(input.ServiceSpecification, context),
        }),
        ...(input.TermInYears != null && { TermInYears: input.TermInYears }),
    };
};
const serializeAws_json1_1GetReservationUtilizationRequest = (input, context) => {
    return {
        ...(input.Filter != null && { Filter: serializeAws_json1_1Expression(input.Filter, context) }),
        ...(input.Granularity != null && { Granularity: input.Granularity }),
        ...(input.GroupBy != null && { GroupBy: serializeAws_json1_1GroupDefinitions(input.GroupBy, context) }),
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.SortBy != null && { SortBy: serializeAws_json1_1SortDefinition(input.SortBy, context) }),
        ...(input.TimePeriod != null && { TimePeriod: serializeAws_json1_1DateInterval(input.TimePeriod, context) }),
    };
};
const serializeAws_json1_1GetRightsizingRecommendationRequest = (input, context) => {
    return {
        ...(input.Configuration != null && {
            Configuration: serializeAws_json1_1RightsizingRecommendationConfiguration(input.Configuration, context),
        }),
        ...(input.Filter != null && { Filter: serializeAws_json1_1Expression(input.Filter, context) }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.PageSize != null && { PageSize: input.PageSize }),
        ...(input.Service != null && { Service: input.Service }),
    };
};
const serializeAws_json1_1GetSavingsPlansCoverageRequest = (input, context) => {
    return {
        ...(input.Filter != null && { Filter: serializeAws_json1_1Expression(input.Filter, context) }),
        ...(input.Granularity != null && { Granularity: input.Granularity }),
        ...(input.GroupBy != null && { GroupBy: serializeAws_json1_1GroupDefinitions(input.GroupBy, context) }),
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.Metrics != null && { Metrics: serializeAws_json1_1MetricNames(input.Metrics, context) }),
        ...(input.NextToken != null && { NextToken: input.NextToken }),
        ...(input.SortBy != null && { SortBy: serializeAws_json1_1SortDefinition(input.SortBy, context) }),
        ...(input.TimePeriod != null && { TimePeriod: serializeAws_json1_1DateInterval(input.TimePeriod, context) }),
    };
};
const serializeAws_json1_1GetSavingsPlansPurchaseRecommendationRequest = (input, context) => {
    return {
        ...(input.AccountScope != null && { AccountScope: input.AccountScope }),
        ...(input.Filter != null && { Filter: serializeAws_json1_1Expression(input.Filter, context) }),
        ...(input.LookbackPeriodInDays != null && { LookbackPeriodInDays: input.LookbackPeriodInDays }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.PageSize != null && { PageSize: input.PageSize }),
        ...(input.PaymentOption != null && { PaymentOption: input.PaymentOption }),
        ...(input.SavingsPlansType != null && { SavingsPlansType: input.SavingsPlansType }),
        ...(input.TermInYears != null && { TermInYears: input.TermInYears }),
    };
};
const serializeAws_json1_1GetSavingsPlansUtilizationDetailsRequest = (input, context) => {
    return {
        ...(input.DataType != null && { DataType: serializeAws_json1_1SavingsPlansDataTypes(input.DataType, context) }),
        ...(input.Filter != null && { Filter: serializeAws_json1_1Expression(input.Filter, context) }),
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.NextToken != null && { NextToken: input.NextToken }),
        ...(input.SortBy != null && { SortBy: serializeAws_json1_1SortDefinition(input.SortBy, context) }),
        ...(input.TimePeriod != null && { TimePeriod: serializeAws_json1_1DateInterval(input.TimePeriod, context) }),
    };
};
const serializeAws_json1_1GetSavingsPlansUtilizationRequest = (input, context) => {
    return {
        ...(input.Filter != null && { Filter: serializeAws_json1_1Expression(input.Filter, context) }),
        ...(input.Granularity != null && { Granularity: input.Granularity }),
        ...(input.SortBy != null && { SortBy: serializeAws_json1_1SortDefinition(input.SortBy, context) }),
        ...(input.TimePeriod != null && { TimePeriod: serializeAws_json1_1DateInterval(input.TimePeriod, context) }),
    };
};
const serializeAws_json1_1GetTagsRequest = (input, context) => {
    return {
        ...(input.Filter != null && { Filter: serializeAws_json1_1Expression(input.Filter, context) }),
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.SearchString != null && { SearchString: input.SearchString }),
        ...(input.SortBy != null && { SortBy: serializeAws_json1_1SortDefinitions(input.SortBy, context) }),
        ...(input.TagKey != null && { TagKey: input.TagKey }),
        ...(input.TimePeriod != null && { TimePeriod: serializeAws_json1_1DateInterval(input.TimePeriod, context) }),
    };
};
const serializeAws_json1_1GetUsageForecastRequest = (input, context) => {
    return {
        ...(input.Filter != null && { Filter: serializeAws_json1_1Expression(input.Filter, context) }),
        ...(input.Granularity != null && { Granularity: input.Granularity }),
        ...(input.Metric != null && { Metric: input.Metric }),
        ...(input.PredictionIntervalLevel != null && { PredictionIntervalLevel: input.PredictionIntervalLevel }),
        ...(input.TimePeriod != null && { TimePeriod: serializeAws_json1_1DateInterval(input.TimePeriod, context) }),
    };
};
const serializeAws_json1_1GroupDefinition = (input, context) => {
    return {
        ...(input.Key != null && { Key: input.Key }),
        ...(input.Type != null && { Type: input.Type }),
    };
};
const serializeAws_json1_1GroupDefinitions = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return serializeAws_json1_1GroupDefinition(entry, context);
    });
};
const serializeAws_json1_1ListCostAllocationTagsRequest = (input, context) => {
    return {
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.NextToken != null && { NextToken: input.NextToken }),
        ...(input.Status != null && { Status: input.Status }),
        ...(input.TagKeys != null && { TagKeys: serializeAws_json1_1CostAllocationTagKeyList(input.TagKeys, context) }),
        ...(input.Type != null && { Type: input.Type }),
    };
};
const serializeAws_json1_1ListCostCategoryDefinitionsRequest = (input, context) => {
    return {
        ...(input.EffectiveOn != null && { EffectiveOn: input.EffectiveOn }),
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.NextToken != null && { NextToken: input.NextToken }),
    };
};
const serializeAws_json1_1ListSavingsPlansPurchaseRecommendationGenerationRequest = (input, context) => {
    return {
        ...(input.GenerationStatus != null && { GenerationStatus: input.GenerationStatus }),
        ...(input.NextPageToken != null && { NextPageToken: input.NextPageToken }),
        ...(input.PageSize != null && { PageSize: input.PageSize }),
        ...(input.RecommendationIds != null && {
            RecommendationIds: serializeAws_json1_1RecommendationIdList(input.RecommendationIds, context),
        }),
    };
};
const serializeAws_json1_1ListTagsForResourceRequest = (input, context) => {
    return {
        ...(input.ResourceArn != null && { ResourceArn: input.ResourceArn }),
    };
};
const serializeAws_json1_1MatchOptions = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const serializeAws_json1_1MetricNames = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const serializeAws_json1_1MonitorArnList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const serializeAws_json1_1ProvideAnomalyFeedbackRequest = (input, context) => {
    return {
        ...(input.AnomalyId != null && { AnomalyId: input.AnomalyId }),
        ...(input.Feedback != null && { Feedback: input.Feedback }),
    };
};
const serializeAws_json1_1RecommendationIdList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const serializeAws_json1_1ResourceTag = (input, context) => {
    return {
        ...(input.Key != null && { Key: input.Key }),
        ...(input.Value != null && { Value: input.Value }),
    };
};
const serializeAws_json1_1ResourceTagKeyList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const serializeAws_json1_1ResourceTagList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return serializeAws_json1_1ResourceTag(entry, context);
    });
};
const serializeAws_json1_1RightsizingRecommendationConfiguration = (input, context) => {
    return {
        ...(input.BenefitsConsidered != null && { BenefitsConsidered: input.BenefitsConsidered }),
        ...(input.RecommendationTarget != null && { RecommendationTarget: input.RecommendationTarget }),
    };
};
const serializeAws_json1_1SavingsPlansDataTypes = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const serializeAws_json1_1ServiceSpecification = (input, context) => {
    return {
        ...(input.EC2Specification != null && {
            EC2Specification: serializeAws_json1_1EC2Specification(input.EC2Specification, context),
        }),
    };
};
const serializeAws_json1_1SortDefinition = (input, context) => {
    return {
        ...(input.Key != null && { Key: input.Key }),
        ...(input.SortOrder != null && { SortOrder: input.SortOrder }),
    };
};
const serializeAws_json1_1SortDefinitions = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return serializeAws_json1_1SortDefinition(entry, context);
    });
};
const serializeAws_json1_1StartSavingsPlansPurchaseRecommendationGenerationRequest = (input, context) => {
    return {};
};
const serializeAws_json1_1Subscriber = (input, context) => {
    return {
        ...(input.Address != null && { Address: input.Address }),
        ...(input.Status != null && { Status: input.Status }),
        ...(input.Type != null && { Type: input.Type }),
    };
};
const serializeAws_json1_1Subscribers = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return serializeAws_json1_1Subscriber(entry, context);
    });
};
const serializeAws_json1_1TagResourceRequest = (input, context) => {
    return {
        ...(input.ResourceArn != null && { ResourceArn: input.ResourceArn }),
        ...(input.ResourceTags != null && {
            ResourceTags: serializeAws_json1_1ResourceTagList(input.ResourceTags, context),
        }),
    };
};
const serializeAws_json1_1TagValues = (input, context) => {
    return {
        ...(input.Key != null && { Key: input.Key }),
        ...(input.MatchOptions != null && { MatchOptions: serializeAws_json1_1MatchOptions(input.MatchOptions, context) }),
        ...(input.Values != null && { Values: serializeAws_json1_1Values(input.Values, context) }),
    };
};
const serializeAws_json1_1TotalImpactFilter = (input, context) => {
    return {
        ...(input.EndValue != null && { EndValue: __serializeFloat(input.EndValue) }),
        ...(input.NumericOperator != null && { NumericOperator: input.NumericOperator }),
        ...(input.StartValue != null && { StartValue: __serializeFloat(input.StartValue) }),
    };
};
const serializeAws_json1_1UntagResourceRequest = (input, context) => {
    return {
        ...(input.ResourceArn != null && { ResourceArn: input.ResourceArn }),
        ...(input.ResourceTagKeys != null && {
            ResourceTagKeys: serializeAws_json1_1ResourceTagKeyList(input.ResourceTagKeys, context),
        }),
    };
};
const serializeAws_json1_1UpdateAnomalyMonitorRequest = (input, context) => {
    return {
        ...(input.MonitorArn != null && { MonitorArn: input.MonitorArn }),
        ...(input.MonitorName != null && { MonitorName: input.MonitorName }),
    };
};
const serializeAws_json1_1UpdateAnomalySubscriptionRequest = (input, context) => {
    return {
        ...(input.Frequency != null && { Frequency: input.Frequency }),
        ...(input.MonitorArnList != null && {
            MonitorArnList: serializeAws_json1_1MonitorArnList(input.MonitorArnList, context),
        }),
        ...(input.Subscribers != null && { Subscribers: serializeAws_json1_1Subscribers(input.Subscribers, context) }),
        ...(input.SubscriptionArn != null && { SubscriptionArn: input.SubscriptionArn }),
        ...(input.SubscriptionName != null && { SubscriptionName: input.SubscriptionName }),
        ...(input.Threshold != null && { Threshold: __serializeFloat(input.Threshold) }),
        ...(input.ThresholdExpression != null && {
            ThresholdExpression: serializeAws_json1_1Expression(input.ThresholdExpression, context),
        }),
    };
};
const serializeAws_json1_1UpdateCostAllocationTagsStatusRequest = (input, context) => {
    return {
        ...(input.CostAllocationTagsStatus != null && {
            CostAllocationTagsStatus: serializeAws_json1_1CostAllocationTagStatusList(input.CostAllocationTagsStatus, context),
        }),
    };
};
const serializeAws_json1_1UpdateCostCategoryDefinitionRequest = (input, context) => {
    return {
        ...(input.CostCategoryArn != null && { CostCategoryArn: input.CostCategoryArn }),
        ...(input.DefaultValue != null && { DefaultValue: input.DefaultValue }),
        ...(input.EffectiveStart != null && { EffectiveStart: input.EffectiveStart }),
        ...(input.RuleVersion != null && { RuleVersion: input.RuleVersion }),
        ...(input.Rules != null && { Rules: serializeAws_json1_1CostCategoryRulesList(input.Rules, context) }),
        ...(input.SplitChargeRules != null && {
            SplitChargeRules: serializeAws_json1_1CostCategorySplitChargeRulesList(input.SplitChargeRules, context),
        }),
    };
};
const serializeAws_json1_1Values = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const deserializeAws_json1_1Anomalies = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1Anomaly(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1Anomaly = (output, context) => {
    return {
        AnomalyEndDate: __expectString(output.AnomalyEndDate),
        AnomalyId: __expectString(output.AnomalyId),
        AnomalyScore: output.AnomalyScore != null ? deserializeAws_json1_1AnomalyScore(output.AnomalyScore, context) : undefined,
        AnomalyStartDate: __expectString(output.AnomalyStartDate),
        DimensionValue: __expectString(output.DimensionValue),
        Feedback: __expectString(output.Feedback),
        Impact: output.Impact != null ? deserializeAws_json1_1Impact(output.Impact, context) : undefined,
        MonitorArn: __expectString(output.MonitorArn),
        RootCauses: output.RootCauses != null ? deserializeAws_json1_1RootCauses(output.RootCauses, context) : undefined,
    };
};
const deserializeAws_json1_1AnomalyMonitor = (output, context) => {
    return {
        CreationDate: __expectString(output.CreationDate),
        DimensionalValueCount: __expectInt32(output.DimensionalValueCount),
        LastEvaluatedDate: __expectString(output.LastEvaluatedDate),
        LastUpdatedDate: __expectString(output.LastUpdatedDate),
        MonitorArn: __expectString(output.MonitorArn),
        MonitorDimension: __expectString(output.MonitorDimension),
        MonitorName: __expectString(output.MonitorName),
        MonitorSpecification: output.MonitorSpecification != null
            ? deserializeAws_json1_1Expression(output.MonitorSpecification, context)
            : undefined,
        MonitorType: __expectString(output.MonitorType),
    };
};
const deserializeAws_json1_1AnomalyMonitors = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1AnomalyMonitor(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1AnomalyScore = (output, context) => {
    return {
        CurrentScore: __limitedParseDouble(output.CurrentScore),
        MaxScore: __limitedParseDouble(output.MaxScore),
    };
};
const deserializeAws_json1_1AnomalySubscription = (output, context) => {
    return {
        AccountId: __expectString(output.AccountId),
        Frequency: __expectString(output.Frequency),
        MonitorArnList: output.MonitorArnList != null ? deserializeAws_json1_1MonitorArnList(output.MonitorArnList, context) : undefined,
        Subscribers: output.Subscribers != null ? deserializeAws_json1_1Subscribers(output.Subscribers, context) : undefined,
        SubscriptionArn: __expectString(output.SubscriptionArn),
        SubscriptionName: __expectString(output.SubscriptionName),
        Threshold: __limitedParseDouble(output.Threshold),
        ThresholdExpression: output.ThresholdExpression != null
            ? deserializeAws_json1_1Expression(output.ThresholdExpression, context)
            : undefined,
    };
};
const deserializeAws_json1_1AnomalySubscriptions = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1AnomalySubscription(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1Attributes = (output, context) => {
    return Object.entries(output).reduce((acc, [key, value]) => {
        if (value === null) {
            return acc;
        }
        acc[key] = __expectString(value);
        return acc;
    }, {});
};
const deserializeAws_json1_1BillExpirationException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const deserializeAws_json1_1CostAllocationTag = (output, context) => {
    return {
        Status: __expectString(output.Status),
        TagKey: __expectString(output.TagKey),
        Type: __expectString(output.Type),
    };
};
const deserializeAws_json1_1CostAllocationTagList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1CostAllocationTag(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1CostCategory = (output, context) => {
    return {
        CostCategoryArn: __expectString(output.CostCategoryArn),
        DefaultValue: __expectString(output.DefaultValue),
        EffectiveEnd: __expectString(output.EffectiveEnd),
        EffectiveStart: __expectString(output.EffectiveStart),
        Name: __expectString(output.Name),
        ProcessingStatus: output.ProcessingStatus != null
            ? deserializeAws_json1_1CostCategoryProcessingStatusList(output.ProcessingStatus, context)
            : undefined,
        RuleVersion: __expectString(output.RuleVersion),
        Rules: output.Rules != null ? deserializeAws_json1_1CostCategoryRulesList(output.Rules, context) : undefined,
        SplitChargeRules: output.SplitChargeRules != null
            ? deserializeAws_json1_1CostCategorySplitChargeRulesList(output.SplitChargeRules, context)
            : undefined,
    };
};
const deserializeAws_json1_1CostCategoryInheritedValueDimension = (output, context) => {
    return {
        DimensionKey: __expectString(output.DimensionKey),
        DimensionName: __expectString(output.DimensionName),
    };
};
const deserializeAws_json1_1CostCategoryNamesList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const deserializeAws_json1_1CostCategoryProcessingStatus = (output, context) => {
    return {
        Component: __expectString(output.Component),
        Status: __expectString(output.Status),
    };
};
const deserializeAws_json1_1CostCategoryProcessingStatusList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1CostCategoryProcessingStatus(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1CostCategoryReference = (output, context) => {
    return {
        CostCategoryArn: __expectString(output.CostCategoryArn),
        DefaultValue: __expectString(output.DefaultValue),
        EffectiveEnd: __expectString(output.EffectiveEnd),
        EffectiveStart: __expectString(output.EffectiveStart),
        Name: __expectString(output.Name),
        NumberOfRules: __expectInt32(output.NumberOfRules),
        ProcessingStatus: output.ProcessingStatus != null
            ? deserializeAws_json1_1CostCategoryProcessingStatusList(output.ProcessingStatus, context)
            : undefined,
        Values: output.Values != null ? deserializeAws_json1_1CostCategoryValuesList(output.Values, context) : undefined,
    };
};
const deserializeAws_json1_1CostCategoryReferencesList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1CostCategoryReference(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1CostCategoryRule = (output, context) => {
    return {
        InheritedValue: output.InheritedValue != null
            ? deserializeAws_json1_1CostCategoryInheritedValueDimension(output.InheritedValue, context)
            : undefined,
        Rule: output.Rule != null ? deserializeAws_json1_1Expression(output.Rule, context) : undefined,
        Type: __expectString(output.Type),
        Value: __expectString(output.Value),
    };
};
const deserializeAws_json1_1CostCategoryRulesList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1CostCategoryRule(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1CostCategorySplitChargeRule = (output, context) => {
    return {
        Method: __expectString(output.Method),
        Parameters: output.Parameters != null
            ? deserializeAws_json1_1CostCategorySplitChargeRuleParametersList(output.Parameters, context)
            : undefined,
        Source: __expectString(output.Source),
        Targets: output.Targets != null
            ? deserializeAws_json1_1CostCategorySplitChargeRuleTargetsList(output.Targets, context)
            : undefined,
    };
};
const deserializeAws_json1_1CostCategorySplitChargeRuleParameter = (output, context) => {
    return {
        Type: __expectString(output.Type),
        Values: output.Values != null
            ? deserializeAws_json1_1CostCategorySplitChargeRuleParameterValuesList(output.Values, context)
            : undefined,
    };
};
const deserializeAws_json1_1CostCategorySplitChargeRuleParametersList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1CostCategorySplitChargeRuleParameter(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1CostCategorySplitChargeRuleParameterValuesList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const deserializeAws_json1_1CostCategorySplitChargeRulesList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1CostCategorySplitChargeRule(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1CostCategorySplitChargeRuleTargetsList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const deserializeAws_json1_1CostCategoryValues = (output, context) => {
    return {
        Key: __expectString(output.Key),
        MatchOptions: output.MatchOptions != null ? deserializeAws_json1_1MatchOptions(output.MatchOptions, context) : undefined,
        Values: output.Values != null ? deserializeAws_json1_1Values(output.Values, context) : undefined,
    };
};
const deserializeAws_json1_1CostCategoryValuesList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const deserializeAws_json1_1Coverage = (output, context) => {
    return {
        CoverageCost: output.CoverageCost != null ? deserializeAws_json1_1CoverageCost(output.CoverageCost, context) : undefined,
        CoverageHours: output.CoverageHours != null ? deserializeAws_json1_1CoverageHours(output.CoverageHours, context) : undefined,
        CoverageNormalizedUnits: output.CoverageNormalizedUnits != null
            ? deserializeAws_json1_1CoverageNormalizedUnits(output.CoverageNormalizedUnits, context)
            : undefined,
    };
};
const deserializeAws_json1_1CoverageByTime = (output, context) => {
    return {
        Groups: output.Groups != null ? deserializeAws_json1_1ReservationCoverageGroups(output.Groups, context) : undefined,
        TimePeriod: output.TimePeriod != null ? deserializeAws_json1_1DateInterval(output.TimePeriod, context) : undefined,
        Total: output.Total != null ? deserializeAws_json1_1Coverage(output.Total, context) : undefined,
    };
};
const deserializeAws_json1_1CoverageCost = (output, context) => {
    return {
        OnDemandCost: __expectString(output.OnDemandCost),
    };
};
const deserializeAws_json1_1CoverageHours = (output, context) => {
    return {
        CoverageHoursPercentage: __expectString(output.CoverageHoursPercentage),
        OnDemandHours: __expectString(output.OnDemandHours),
        ReservedHours: __expectString(output.ReservedHours),
        TotalRunningHours: __expectString(output.TotalRunningHours),
    };
};
const deserializeAws_json1_1CoverageNormalizedUnits = (output, context) => {
    return {
        CoverageNormalizedUnitsPercentage: __expectString(output.CoverageNormalizedUnitsPercentage),
        OnDemandNormalizedUnits: __expectString(output.OnDemandNormalizedUnits),
        ReservedNormalizedUnits: __expectString(output.ReservedNormalizedUnits),
        TotalRunningNormalizedUnits: __expectString(output.TotalRunningNormalizedUnits),
    };
};
const deserializeAws_json1_1CoveragesByTime = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1CoverageByTime(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1CreateAnomalyMonitorResponse = (output, context) => {
    return {
        MonitorArn: __expectString(output.MonitorArn),
    };
};
const deserializeAws_json1_1CreateAnomalySubscriptionResponse = (output, context) => {
    return {
        SubscriptionArn: __expectString(output.SubscriptionArn),
    };
};
const deserializeAws_json1_1CreateCostCategoryDefinitionResponse = (output, context) => {
    return {
        CostCategoryArn: __expectString(output.CostCategoryArn),
        EffectiveStart: __expectString(output.EffectiveStart),
    };
};
const deserializeAws_json1_1CurrentInstance = (output, context) => {
    return {
        CurrencyCode: __expectString(output.CurrencyCode),
        InstanceName: __expectString(output.InstanceName),
        MonthlyCost: __expectString(output.MonthlyCost),
        OnDemandHoursInLookbackPeriod: __expectString(output.OnDemandHoursInLookbackPeriod),
        ReservationCoveredHoursInLookbackPeriod: __expectString(output.ReservationCoveredHoursInLookbackPeriod),
        ResourceDetails: output.ResourceDetails != null
            ? deserializeAws_json1_1ResourceDetails(output.ResourceDetails, context)
            : undefined,
        ResourceId: __expectString(output.ResourceId),
        ResourceUtilization: output.ResourceUtilization != null
            ? deserializeAws_json1_1ResourceUtilization(output.ResourceUtilization, context)
            : undefined,
        SavingsPlansCoveredHoursInLookbackPeriod: __expectString(output.SavingsPlansCoveredHoursInLookbackPeriod),
        Tags: output.Tags != null ? deserializeAws_json1_1TagValuesList(output.Tags, context) : undefined,
        TotalRunningHoursInLookbackPeriod: __expectString(output.TotalRunningHoursInLookbackPeriod),
    };
};
const deserializeAws_json1_1DataUnavailableException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const deserializeAws_json1_1DateInterval = (output, context) => {
    return {
        End: __expectString(output.End),
        Start: __expectString(output.Start),
    };
};
const deserializeAws_json1_1DeleteAnomalyMonitorResponse = (output, context) => {
    return {};
};
const deserializeAws_json1_1DeleteAnomalySubscriptionResponse = (output, context) => {
    return {};
};
const deserializeAws_json1_1DeleteCostCategoryDefinitionResponse = (output, context) => {
    return {
        CostCategoryArn: __expectString(output.CostCategoryArn),
        EffectiveEnd: __expectString(output.EffectiveEnd),
    };
};
const deserializeAws_json1_1DescribeCostCategoryDefinitionResponse = (output, context) => {
    return {
        CostCategory: output.CostCategory != null ? deserializeAws_json1_1CostCategory(output.CostCategory, context) : undefined,
    };
};
const deserializeAws_json1_1DimensionValues = (output, context) => {
    return {
        Key: __expectString(output.Key),
        MatchOptions: output.MatchOptions != null ? deserializeAws_json1_1MatchOptions(output.MatchOptions, context) : undefined,
        Values: output.Values != null ? deserializeAws_json1_1Values(output.Values, context) : undefined,
    };
};
const deserializeAws_json1_1DimensionValuesWithAttributes = (output, context) => {
    return {
        Attributes: output.Attributes != null ? deserializeAws_json1_1Attributes(output.Attributes, context) : undefined,
        Value: __expectString(output.Value),
    };
};
const deserializeAws_json1_1DimensionValuesWithAttributesList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1DimensionValuesWithAttributes(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1DiskResourceUtilization = (output, context) => {
    return {
        DiskReadBytesPerSecond: __expectString(output.DiskReadBytesPerSecond),
        DiskReadOpsPerSecond: __expectString(output.DiskReadOpsPerSecond),
        DiskWriteBytesPerSecond: __expectString(output.DiskWriteBytesPerSecond),
        DiskWriteOpsPerSecond: __expectString(output.DiskWriteOpsPerSecond),
    };
};
const deserializeAws_json1_1EBSResourceUtilization = (output, context) => {
    return {
        EbsReadBytesPerSecond: __expectString(output.EbsReadBytesPerSecond),
        EbsReadOpsPerSecond: __expectString(output.EbsReadOpsPerSecond),
        EbsWriteBytesPerSecond: __expectString(output.EbsWriteBytesPerSecond),
        EbsWriteOpsPerSecond: __expectString(output.EbsWriteOpsPerSecond),
    };
};
const deserializeAws_json1_1EC2InstanceDetails = (output, context) => {
    return {
        AvailabilityZone: __expectString(output.AvailabilityZone),
        CurrentGeneration: __expectBoolean(output.CurrentGeneration),
        Family: __expectString(output.Family),
        InstanceType: __expectString(output.InstanceType),
        Platform: __expectString(output.Platform),
        Region: __expectString(output.Region),
        SizeFlexEligible: __expectBoolean(output.SizeFlexEligible),
        Tenancy: __expectString(output.Tenancy),
    };
};
const deserializeAws_json1_1EC2ResourceDetails = (output, context) => {
    return {
        HourlyOnDemandRate: __expectString(output.HourlyOnDemandRate),
        InstanceType: __expectString(output.InstanceType),
        Memory: __expectString(output.Memory),
        NetworkPerformance: __expectString(output.NetworkPerformance),
        Platform: __expectString(output.Platform),
        Region: __expectString(output.Region),
        Sku: __expectString(output.Sku),
        Storage: __expectString(output.Storage),
        Vcpu: __expectString(output.Vcpu),
    };
};
const deserializeAws_json1_1EC2ResourceUtilization = (output, context) => {
    return {
        DiskResourceUtilization: output.DiskResourceUtilization != null
            ? deserializeAws_json1_1DiskResourceUtilization(output.DiskResourceUtilization, context)
            : undefined,
        EBSResourceUtilization: output.EBSResourceUtilization != null
            ? deserializeAws_json1_1EBSResourceUtilization(output.EBSResourceUtilization, context)
            : undefined,
        MaxCpuUtilizationPercentage: __expectString(output.MaxCpuUtilizationPercentage),
        MaxMemoryUtilizationPercentage: __expectString(output.MaxMemoryUtilizationPercentage),
        MaxStorageUtilizationPercentage: __expectString(output.MaxStorageUtilizationPercentage),
        NetworkResourceUtilization: output.NetworkResourceUtilization != null
            ? deserializeAws_json1_1NetworkResourceUtilization(output.NetworkResourceUtilization, context)
            : undefined,
    };
};
const deserializeAws_json1_1EC2Specification = (output, context) => {
    return {
        OfferingClass: __expectString(output.OfferingClass),
    };
};
const deserializeAws_json1_1ElastiCacheInstanceDetails = (output, context) => {
    return {
        CurrentGeneration: __expectBoolean(output.CurrentGeneration),
        Family: __expectString(output.Family),
        NodeType: __expectString(output.NodeType),
        ProductDescription: __expectString(output.ProductDescription),
        Region: __expectString(output.Region),
        SizeFlexEligible: __expectBoolean(output.SizeFlexEligible),
    };
};
const deserializeAws_json1_1ESInstanceDetails = (output, context) => {
    return {
        CurrentGeneration: __expectBoolean(output.CurrentGeneration),
        InstanceClass: __expectString(output.InstanceClass),
        InstanceSize: __expectString(output.InstanceSize),
        Region: __expectString(output.Region),
        SizeFlexEligible: __expectBoolean(output.SizeFlexEligible),
    };
};
const deserializeAws_json1_1Expression = (output, context) => {
    return {
        And: output.And != null ? deserializeAws_json1_1Expressions(output.And, context) : undefined,
        CostCategories: output.CostCategories != null
            ? deserializeAws_json1_1CostCategoryValues(output.CostCategories, context)
            : undefined,
        Dimensions: output.Dimensions != null ? deserializeAws_json1_1DimensionValues(output.Dimensions, context) : undefined,
        Not: output.Not != null ? deserializeAws_json1_1Expression(output.Not, context) : undefined,
        Or: output.Or != null ? deserializeAws_json1_1Expressions(output.Or, context) : undefined,
        Tags: output.Tags != null ? deserializeAws_json1_1TagValues(output.Tags, context) : undefined,
    };
};
const deserializeAws_json1_1Expressions = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1Expression(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1FindingReasonCodes = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const deserializeAws_json1_1ForecastResult = (output, context) => {
    return {
        MeanValue: __expectString(output.MeanValue),
        PredictionIntervalLowerBound: __expectString(output.PredictionIntervalLowerBound),
        PredictionIntervalUpperBound: __expectString(output.PredictionIntervalUpperBound),
        TimePeriod: output.TimePeriod != null ? deserializeAws_json1_1DateInterval(output.TimePeriod, context) : undefined,
    };
};
const deserializeAws_json1_1ForecastResultsByTime = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1ForecastResult(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1GenerationExistsException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const deserializeAws_json1_1GenerationSummary = (output, context) => {
    return {
        EstimatedCompletionTime: __expectString(output.EstimatedCompletionTime),
        GenerationCompletionTime: __expectString(output.GenerationCompletionTime),
        GenerationStartedTime: __expectString(output.GenerationStartedTime),
        GenerationStatus: __expectString(output.GenerationStatus),
        RecommendationId: __expectString(output.RecommendationId),
    };
};
const deserializeAws_json1_1GenerationSummaryList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1GenerationSummary(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1GetAnomaliesResponse = (output, context) => {
    return {
        Anomalies: output.Anomalies != null ? deserializeAws_json1_1Anomalies(output.Anomalies, context) : undefined,
        NextPageToken: __expectString(output.NextPageToken),
    };
};
const deserializeAws_json1_1GetAnomalyMonitorsResponse = (output, context) => {
    return {
        AnomalyMonitors: output.AnomalyMonitors != null
            ? deserializeAws_json1_1AnomalyMonitors(output.AnomalyMonitors, context)
            : undefined,
        NextPageToken: __expectString(output.NextPageToken),
    };
};
const deserializeAws_json1_1GetAnomalySubscriptionsResponse = (output, context) => {
    return {
        AnomalySubscriptions: output.AnomalySubscriptions != null
            ? deserializeAws_json1_1AnomalySubscriptions(output.AnomalySubscriptions, context)
            : undefined,
        NextPageToken: __expectString(output.NextPageToken),
    };
};
const deserializeAws_json1_1GetCostAndUsageResponse = (output, context) => {
    return {
        DimensionValueAttributes: output.DimensionValueAttributes != null
            ? deserializeAws_json1_1DimensionValuesWithAttributesList(output.DimensionValueAttributes, context)
            : undefined,
        GroupDefinitions: output.GroupDefinitions != null
            ? deserializeAws_json1_1GroupDefinitions(output.GroupDefinitions, context)
            : undefined,
        NextPageToken: __expectString(output.NextPageToken),
        ResultsByTime: output.ResultsByTime != null ? deserializeAws_json1_1ResultsByTime(output.ResultsByTime, context) : undefined,
    };
};
const deserializeAws_json1_1GetCostAndUsageWithResourcesResponse = (output, context) => {
    return {
        DimensionValueAttributes: output.DimensionValueAttributes != null
            ? deserializeAws_json1_1DimensionValuesWithAttributesList(output.DimensionValueAttributes, context)
            : undefined,
        GroupDefinitions: output.GroupDefinitions != null
            ? deserializeAws_json1_1GroupDefinitions(output.GroupDefinitions, context)
            : undefined,
        NextPageToken: __expectString(output.NextPageToken),
        ResultsByTime: output.ResultsByTime != null ? deserializeAws_json1_1ResultsByTime(output.ResultsByTime, context) : undefined,
    };
};
const deserializeAws_json1_1GetCostCategoriesResponse = (output, context) => {
    return {
        CostCategoryNames: output.CostCategoryNames != null
            ? deserializeAws_json1_1CostCategoryNamesList(output.CostCategoryNames, context)
            : undefined,
        CostCategoryValues: output.CostCategoryValues != null
            ? deserializeAws_json1_1CostCategoryValuesList(output.CostCategoryValues, context)
            : undefined,
        NextPageToken: __expectString(output.NextPageToken),
        ReturnSize: __expectInt32(output.ReturnSize),
        TotalSize: __expectInt32(output.TotalSize),
    };
};
const deserializeAws_json1_1GetCostForecastResponse = (output, context) => {
    return {
        ForecastResultsByTime: output.ForecastResultsByTime != null
            ? deserializeAws_json1_1ForecastResultsByTime(output.ForecastResultsByTime, context)
            : undefined,
        Total: output.Total != null ? deserializeAws_json1_1MetricValue(output.Total, context) : undefined,
    };
};
const deserializeAws_json1_1GetDimensionValuesResponse = (output, context) => {
    return {
        DimensionValues: output.DimensionValues != null
            ? deserializeAws_json1_1DimensionValuesWithAttributesList(output.DimensionValues, context)
            : undefined,
        NextPageToken: __expectString(output.NextPageToken),
        ReturnSize: __expectInt32(output.ReturnSize),
        TotalSize: __expectInt32(output.TotalSize),
    };
};
const deserializeAws_json1_1GetReservationCoverageResponse = (output, context) => {
    return {
        CoveragesByTime: output.CoveragesByTime != null
            ? deserializeAws_json1_1CoveragesByTime(output.CoveragesByTime, context)
            : undefined,
        NextPageToken: __expectString(output.NextPageToken),
        Total: output.Total != null ? deserializeAws_json1_1Coverage(output.Total, context) : undefined,
    };
};
const deserializeAws_json1_1GetReservationPurchaseRecommendationResponse = (output, context) => {
    return {
        Metadata: output.Metadata != null
            ? deserializeAws_json1_1ReservationPurchaseRecommendationMetadata(output.Metadata, context)
            : undefined,
        NextPageToken: __expectString(output.NextPageToken),
        Recommendations: output.Recommendations != null
            ? deserializeAws_json1_1ReservationPurchaseRecommendations(output.Recommendations, context)
            : undefined,
    };
};
const deserializeAws_json1_1GetReservationUtilizationResponse = (output, context) => {
    return {
        NextPageToken: __expectString(output.NextPageToken),
        Total: output.Total != null ? deserializeAws_json1_1ReservationAggregates(output.Total, context) : undefined,
        UtilizationsByTime: output.UtilizationsByTime != null
            ? deserializeAws_json1_1UtilizationsByTime(output.UtilizationsByTime, context)
            : undefined,
    };
};
const deserializeAws_json1_1GetRightsizingRecommendationResponse = (output, context) => {
    return {
        Configuration: output.Configuration != null
            ? deserializeAws_json1_1RightsizingRecommendationConfiguration(output.Configuration, context)
            : undefined,
        Metadata: output.Metadata != null
            ? deserializeAws_json1_1RightsizingRecommendationMetadata(output.Metadata, context)
            : undefined,
        NextPageToken: __expectString(output.NextPageToken),
        RightsizingRecommendations: output.RightsizingRecommendations != null
            ? deserializeAws_json1_1RightsizingRecommendationList(output.RightsizingRecommendations, context)
            : undefined,
        Summary: output.Summary != null
            ? deserializeAws_json1_1RightsizingRecommendationSummary(output.Summary, context)
            : undefined,
    };
};
const deserializeAws_json1_1GetSavingsPlansCoverageResponse = (output, context) => {
    return {
        NextToken: __expectString(output.NextToken),
        SavingsPlansCoverages: output.SavingsPlansCoverages != null
            ? deserializeAws_json1_1SavingsPlansCoverages(output.SavingsPlansCoverages, context)
            : undefined,
    };
};
const deserializeAws_json1_1GetSavingsPlansPurchaseRecommendationResponse = (output, context) => {
    return {
        Metadata: output.Metadata != null
            ? deserializeAws_json1_1SavingsPlansPurchaseRecommendationMetadata(output.Metadata, context)
            : undefined,
        NextPageToken: __expectString(output.NextPageToken),
        SavingsPlansPurchaseRecommendation: output.SavingsPlansPurchaseRecommendation != null
            ? deserializeAws_json1_1SavingsPlansPurchaseRecommendation(output.SavingsPlansPurchaseRecommendation, context)
            : undefined,
    };
};
const deserializeAws_json1_1GetSavingsPlansUtilizationDetailsResponse = (output, context) => {
    return {
        NextToken: __expectString(output.NextToken),
        SavingsPlansUtilizationDetails: output.SavingsPlansUtilizationDetails != null
            ? deserializeAws_json1_1SavingsPlansUtilizationDetails(output.SavingsPlansUtilizationDetails, context)
            : undefined,
        TimePeriod: output.TimePeriod != null ? deserializeAws_json1_1DateInterval(output.TimePeriod, context) : undefined,
        Total: output.Total != null ? deserializeAws_json1_1SavingsPlansUtilizationAggregates(output.Total, context) : undefined,
    };
};
const deserializeAws_json1_1GetSavingsPlansUtilizationResponse = (output, context) => {
    return {
        SavingsPlansUtilizationsByTime: output.SavingsPlansUtilizationsByTime != null
            ? deserializeAws_json1_1SavingsPlansUtilizationsByTime(output.SavingsPlansUtilizationsByTime, context)
            : undefined,
        Total: output.Total != null ? deserializeAws_json1_1SavingsPlansUtilizationAggregates(output.Total, context) : undefined,
    };
};
const deserializeAws_json1_1GetTagsResponse = (output, context) => {
    return {
        NextPageToken: __expectString(output.NextPageToken),
        ReturnSize: __expectInt32(output.ReturnSize),
        Tags: output.Tags != null ? deserializeAws_json1_1TagList(output.Tags, context) : undefined,
        TotalSize: __expectInt32(output.TotalSize),
    };
};
const deserializeAws_json1_1GetUsageForecastResponse = (output, context) => {
    return {
        ForecastResultsByTime: output.ForecastResultsByTime != null
            ? deserializeAws_json1_1ForecastResultsByTime(output.ForecastResultsByTime, context)
            : undefined,
        Total: output.Total != null ? deserializeAws_json1_1MetricValue(output.Total, context) : undefined,
    };
};
const deserializeAws_json1_1Group = (output, context) => {
    return {
        Keys: output.Keys != null ? deserializeAws_json1_1Keys(output.Keys, context) : undefined,
        Metrics: output.Metrics != null ? deserializeAws_json1_1Metrics(output.Metrics, context) : undefined,
    };
};
const deserializeAws_json1_1GroupDefinition = (output, context) => {
    return {
        Key: __expectString(output.Key),
        Type: __expectString(output.Type),
    };
};
const deserializeAws_json1_1GroupDefinitions = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1GroupDefinition(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1Groups = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1Group(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1Impact = (output, context) => {
    return {
        MaxImpact: __limitedParseDouble(output.MaxImpact),
        TotalActualSpend: __limitedParseDouble(output.TotalActualSpend),
        TotalExpectedSpend: __limitedParseDouble(output.TotalExpectedSpend),
        TotalImpact: __limitedParseDouble(output.TotalImpact),
        TotalImpactPercentage: __limitedParseDouble(output.TotalImpactPercentage),
    };
};
const deserializeAws_json1_1InstanceDetails = (output, context) => {
    return {
        EC2InstanceDetails: output.EC2InstanceDetails != null
            ? deserializeAws_json1_1EC2InstanceDetails(output.EC2InstanceDetails, context)
            : undefined,
        ESInstanceDetails: output.ESInstanceDetails != null
            ? deserializeAws_json1_1ESInstanceDetails(output.ESInstanceDetails, context)
            : undefined,
        ElastiCacheInstanceDetails: output.ElastiCacheInstanceDetails != null
            ? deserializeAws_json1_1ElastiCacheInstanceDetails(output.ElastiCacheInstanceDetails, context)
            : undefined,
        RDSInstanceDetails: output.RDSInstanceDetails != null
            ? deserializeAws_json1_1RDSInstanceDetails(output.RDSInstanceDetails, context)
            : undefined,
        RedshiftInstanceDetails: output.RedshiftInstanceDetails != null
            ? deserializeAws_json1_1RedshiftInstanceDetails(output.RedshiftInstanceDetails, context)
            : undefined,
    };
};
const deserializeAws_json1_1InvalidNextTokenException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const deserializeAws_json1_1Keys = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const deserializeAws_json1_1LimitExceededException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const deserializeAws_json1_1ListCostAllocationTagsResponse = (output, context) => {
    return {
        CostAllocationTags: output.CostAllocationTags != null
            ? deserializeAws_json1_1CostAllocationTagList(output.CostAllocationTags, context)
            : undefined,
        NextToken: __expectString(output.NextToken),
    };
};
const deserializeAws_json1_1ListCostCategoryDefinitionsResponse = (output, context) => {
    return {
        CostCategoryReferences: output.CostCategoryReferences != null
            ? deserializeAws_json1_1CostCategoryReferencesList(output.CostCategoryReferences, context)
            : undefined,
        NextToken: __expectString(output.NextToken),
    };
};
const deserializeAws_json1_1ListSavingsPlansPurchaseRecommendationGenerationResponse = (output, context) => {
    return {
        GenerationSummaryList: output.GenerationSummaryList != null
            ? deserializeAws_json1_1GenerationSummaryList(output.GenerationSummaryList, context)
            : undefined,
        NextPageToken: __expectString(output.NextPageToken),
    };
};
const deserializeAws_json1_1ListTagsForResourceResponse = (output, context) => {
    return {
        ResourceTags: output.ResourceTags != null ? deserializeAws_json1_1ResourceTagList(output.ResourceTags, context) : undefined,
    };
};
const deserializeAws_json1_1MatchOptions = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const deserializeAws_json1_1Metrics = (output, context) => {
    return Object.entries(output).reduce((acc, [key, value]) => {
        if (value === null) {
            return acc;
        }
        acc[key] = deserializeAws_json1_1MetricValue(value, context);
        return acc;
    }, {});
};
const deserializeAws_json1_1MetricValue = (output, context) => {
    return {
        Amount: __expectString(output.Amount),
        Unit: __expectString(output.Unit),
    };
};
const deserializeAws_json1_1ModifyRecommendationDetail = (output, context) => {
    return {
        TargetInstances: output.TargetInstances != null
            ? deserializeAws_json1_1TargetInstancesList(output.TargetInstances, context)
            : undefined,
    };
};
const deserializeAws_json1_1MonitorArnList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const deserializeAws_json1_1NetworkResourceUtilization = (output, context) => {
    return {
        NetworkInBytesPerSecond: __expectString(output.NetworkInBytesPerSecond),
        NetworkOutBytesPerSecond: __expectString(output.NetworkOutBytesPerSecond),
        NetworkPacketsInPerSecond: __expectString(output.NetworkPacketsInPerSecond),
        NetworkPacketsOutPerSecond: __expectString(output.NetworkPacketsOutPerSecond),
    };
};
const deserializeAws_json1_1PlatformDifferences = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const deserializeAws_json1_1ProvideAnomalyFeedbackResponse = (output, context) => {
    return {
        AnomalyId: __expectString(output.AnomalyId),
    };
};
const deserializeAws_json1_1RDSInstanceDetails = (output, context) => {
    return {
        CurrentGeneration: __expectBoolean(output.CurrentGeneration),
        DatabaseEdition: __expectString(output.DatabaseEdition),
        DatabaseEngine: __expectString(output.DatabaseEngine),
        DeploymentOption: __expectString(output.DeploymentOption),
        Family: __expectString(output.Family),
        InstanceType: __expectString(output.InstanceType),
        LicenseModel: __expectString(output.LicenseModel),
        Region: __expectString(output.Region),
        SizeFlexEligible: __expectBoolean(output.SizeFlexEligible),
    };
};
const deserializeAws_json1_1RedshiftInstanceDetails = (output, context) => {
    return {
        CurrentGeneration: __expectBoolean(output.CurrentGeneration),
        Family: __expectString(output.Family),
        NodeType: __expectString(output.NodeType),
        Region: __expectString(output.Region),
        SizeFlexEligible: __expectBoolean(output.SizeFlexEligible),
    };
};
const deserializeAws_json1_1RequestChangedException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const deserializeAws_json1_1ReservationAggregates = (output, context) => {
    return {
        AmortizedRecurringFee: __expectString(output.AmortizedRecurringFee),
        AmortizedUpfrontFee: __expectString(output.AmortizedUpfrontFee),
        NetRISavings: __expectString(output.NetRISavings),
        OnDemandCostOfRIHoursUsed: __expectString(output.OnDemandCostOfRIHoursUsed),
        PurchasedHours: __expectString(output.PurchasedHours),
        PurchasedUnits: __expectString(output.PurchasedUnits),
        RICostForUnusedHours: __expectString(output.RICostForUnusedHours),
        RealizedSavings: __expectString(output.RealizedSavings),
        TotalActualHours: __expectString(output.TotalActualHours),
        TotalActualUnits: __expectString(output.TotalActualUnits),
        TotalAmortizedFee: __expectString(output.TotalAmortizedFee),
        TotalPotentialRISavings: __expectString(output.TotalPotentialRISavings),
        UnrealizedSavings: __expectString(output.UnrealizedSavings),
        UnusedHours: __expectString(output.UnusedHours),
        UnusedUnits: __expectString(output.UnusedUnits),
        UtilizationPercentage: __expectString(output.UtilizationPercentage),
        UtilizationPercentageInUnits: __expectString(output.UtilizationPercentageInUnits),
    };
};
const deserializeAws_json1_1ReservationCoverageGroup = (output, context) => {
    return {
        Attributes: output.Attributes != null ? deserializeAws_json1_1Attributes(output.Attributes, context) : undefined,
        Coverage: output.Coverage != null ? deserializeAws_json1_1Coverage(output.Coverage, context) : undefined,
    };
};
const deserializeAws_json1_1ReservationCoverageGroups = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1ReservationCoverageGroup(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1ReservationPurchaseRecommendation = (output, context) => {
    return {
        AccountScope: __expectString(output.AccountScope),
        LookbackPeriodInDays: __expectString(output.LookbackPeriodInDays),
        PaymentOption: __expectString(output.PaymentOption),
        RecommendationDetails: output.RecommendationDetails != null
            ? deserializeAws_json1_1ReservationPurchaseRecommendationDetails(output.RecommendationDetails, context)
            : undefined,
        RecommendationSummary: output.RecommendationSummary != null
            ? deserializeAws_json1_1ReservationPurchaseRecommendationSummary(output.RecommendationSummary, context)
            : undefined,
        ServiceSpecification: output.ServiceSpecification != null
            ? deserializeAws_json1_1ServiceSpecification(output.ServiceSpecification, context)
            : undefined,
        TermInYears: __expectString(output.TermInYears),
    };
};
const deserializeAws_json1_1ReservationPurchaseRecommendationDetail = (output, context) => {
    return {
        AccountId: __expectString(output.AccountId),
        AverageNormalizedUnitsUsedPerHour: __expectString(output.AverageNormalizedUnitsUsedPerHour),
        AverageNumberOfInstancesUsedPerHour: __expectString(output.AverageNumberOfInstancesUsedPerHour),
        AverageUtilization: __expectString(output.AverageUtilization),
        CurrencyCode: __expectString(output.CurrencyCode),
        EstimatedBreakEvenInMonths: __expectString(output.EstimatedBreakEvenInMonths),
        EstimatedMonthlyOnDemandCost: __expectString(output.EstimatedMonthlyOnDemandCost),
        EstimatedMonthlySavingsAmount: __expectString(output.EstimatedMonthlySavingsAmount),
        EstimatedMonthlySavingsPercentage: __expectString(output.EstimatedMonthlySavingsPercentage),
        EstimatedReservationCostForLookbackPeriod: __expectString(output.EstimatedReservationCostForLookbackPeriod),
        InstanceDetails: output.InstanceDetails != null
            ? deserializeAws_json1_1InstanceDetails(output.InstanceDetails, context)
            : undefined,
        MaximumNormalizedUnitsUsedPerHour: __expectString(output.MaximumNormalizedUnitsUsedPerHour),
        MaximumNumberOfInstancesUsedPerHour: __expectString(output.MaximumNumberOfInstancesUsedPerHour),
        MinimumNormalizedUnitsUsedPerHour: __expectString(output.MinimumNormalizedUnitsUsedPerHour),
        MinimumNumberOfInstancesUsedPerHour: __expectString(output.MinimumNumberOfInstancesUsedPerHour),
        RecommendedNormalizedUnitsToPurchase: __expectString(output.RecommendedNormalizedUnitsToPurchase),
        RecommendedNumberOfInstancesToPurchase: __expectString(output.RecommendedNumberOfInstancesToPurchase),
        RecurringStandardMonthlyCost: __expectString(output.RecurringStandardMonthlyCost),
        UpfrontCost: __expectString(output.UpfrontCost),
    };
};
const deserializeAws_json1_1ReservationPurchaseRecommendationDetails = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1ReservationPurchaseRecommendationDetail(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1ReservationPurchaseRecommendationMetadata = (output, context) => {
    return {
        GenerationTimestamp: __expectString(output.GenerationTimestamp),
        RecommendationId: __expectString(output.RecommendationId),
    };
};
const deserializeAws_json1_1ReservationPurchaseRecommendations = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1ReservationPurchaseRecommendation(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1ReservationPurchaseRecommendationSummary = (output, context) => {
    return {
        CurrencyCode: __expectString(output.CurrencyCode),
        TotalEstimatedMonthlySavingsAmount: __expectString(output.TotalEstimatedMonthlySavingsAmount),
        TotalEstimatedMonthlySavingsPercentage: __expectString(output.TotalEstimatedMonthlySavingsPercentage),
    };
};
const deserializeAws_json1_1ReservationUtilizationGroup = (output, context) => {
    return {
        Attributes: output.Attributes != null ? deserializeAws_json1_1Attributes(output.Attributes, context) : undefined,
        Key: __expectString(output.Key),
        Utilization: output.Utilization != null ? deserializeAws_json1_1ReservationAggregates(output.Utilization, context) : undefined,
        Value: __expectString(output.Value),
    };
};
const deserializeAws_json1_1ReservationUtilizationGroups = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1ReservationUtilizationGroup(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1ResourceDetails = (output, context) => {
    return {
        EC2ResourceDetails: output.EC2ResourceDetails != null
            ? deserializeAws_json1_1EC2ResourceDetails(output.EC2ResourceDetails, context)
            : undefined,
    };
};
const deserializeAws_json1_1ResourceNotFoundException = (output, context) => {
    return {
        Message: __expectString(output.Message),
        ResourceName: __expectString(output.ResourceName),
    };
};
const deserializeAws_json1_1ResourceTag = (output, context) => {
    return {
        Key: __expectString(output.Key),
        Value: __expectString(output.Value),
    };
};
const deserializeAws_json1_1ResourceTagList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1ResourceTag(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1ResourceUtilization = (output, context) => {
    return {
        EC2ResourceUtilization: output.EC2ResourceUtilization != null
            ? deserializeAws_json1_1EC2ResourceUtilization(output.EC2ResourceUtilization, context)
            : undefined,
    };
};
const deserializeAws_json1_1ResultByTime = (output, context) => {
    return {
        Estimated: __expectBoolean(output.Estimated),
        Groups: output.Groups != null ? deserializeAws_json1_1Groups(output.Groups, context) : undefined,
        TimePeriod: output.TimePeriod != null ? deserializeAws_json1_1DateInterval(output.TimePeriod, context) : undefined,
        Total: output.Total != null ? deserializeAws_json1_1Metrics(output.Total, context) : undefined,
    };
};
const deserializeAws_json1_1ResultsByTime = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1ResultByTime(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1RightsizingRecommendation = (output, context) => {
    return {
        AccountId: __expectString(output.AccountId),
        CurrentInstance: output.CurrentInstance != null
            ? deserializeAws_json1_1CurrentInstance(output.CurrentInstance, context)
            : undefined,
        FindingReasonCodes: output.FindingReasonCodes != null
            ? deserializeAws_json1_1FindingReasonCodes(output.FindingReasonCodes, context)
            : undefined,
        ModifyRecommendationDetail: output.ModifyRecommendationDetail != null
            ? deserializeAws_json1_1ModifyRecommendationDetail(output.ModifyRecommendationDetail, context)
            : undefined,
        RightsizingType: __expectString(output.RightsizingType),
        TerminateRecommendationDetail: output.TerminateRecommendationDetail != null
            ? deserializeAws_json1_1TerminateRecommendationDetail(output.TerminateRecommendationDetail, context)
            : undefined,
    };
};
const deserializeAws_json1_1RightsizingRecommendationConfiguration = (output, context) => {
    return {
        BenefitsConsidered: __expectBoolean(output.BenefitsConsidered),
        RecommendationTarget: __expectString(output.RecommendationTarget),
    };
};
const deserializeAws_json1_1RightsizingRecommendationList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1RightsizingRecommendation(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1RightsizingRecommendationMetadata = (output, context) => {
    return {
        AdditionalMetadata: __expectString(output.AdditionalMetadata),
        GenerationTimestamp: __expectString(output.GenerationTimestamp),
        LookbackPeriodInDays: __expectString(output.LookbackPeriodInDays),
        RecommendationId: __expectString(output.RecommendationId),
    };
};
const deserializeAws_json1_1RightsizingRecommendationSummary = (output, context) => {
    return {
        EstimatedTotalMonthlySavingsAmount: __expectString(output.EstimatedTotalMonthlySavingsAmount),
        SavingsCurrencyCode: __expectString(output.SavingsCurrencyCode),
        SavingsPercentage: __expectString(output.SavingsPercentage),
        TotalRecommendationCount: __expectString(output.TotalRecommendationCount),
    };
};
const deserializeAws_json1_1RootCause = (output, context) => {
    return {
        LinkedAccount: __expectString(output.LinkedAccount),
        LinkedAccountName: __expectString(output.LinkedAccountName),
        Region: __expectString(output.Region),
        Service: __expectString(output.Service),
        UsageType: __expectString(output.UsageType),
    };
};
const deserializeAws_json1_1RootCauses = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1RootCause(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1SavingsPlansAmortizedCommitment = (output, context) => {
    return {
        AmortizedRecurringCommitment: __expectString(output.AmortizedRecurringCommitment),
        AmortizedUpfrontCommitment: __expectString(output.AmortizedUpfrontCommitment),
        TotalAmortizedCommitment: __expectString(output.TotalAmortizedCommitment),
    };
};
const deserializeAws_json1_1SavingsPlansCoverage = (output, context) => {
    return {
        Attributes: output.Attributes != null ? deserializeAws_json1_1Attributes(output.Attributes, context) : undefined,
        Coverage: output.Coverage != null ? deserializeAws_json1_1SavingsPlansCoverageData(output.Coverage, context) : undefined,
        TimePeriod: output.TimePeriod != null ? deserializeAws_json1_1DateInterval(output.TimePeriod, context) : undefined,
    };
};
const deserializeAws_json1_1SavingsPlansCoverageData = (output, context) => {
    return {
        CoveragePercentage: __expectString(output.CoveragePercentage),
        OnDemandCost: __expectString(output.OnDemandCost),
        SpendCoveredBySavingsPlans: __expectString(output.SpendCoveredBySavingsPlans),
        TotalCost: __expectString(output.TotalCost),
    };
};
const deserializeAws_json1_1SavingsPlansCoverages = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1SavingsPlansCoverage(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1SavingsPlansDetails = (output, context) => {
    return {
        InstanceFamily: __expectString(output.InstanceFamily),
        OfferingId: __expectString(output.OfferingId),
        Region: __expectString(output.Region),
    };
};
const deserializeAws_json1_1SavingsPlansPurchaseRecommendation = (output, context) => {
    return {
        AccountScope: __expectString(output.AccountScope),
        LookbackPeriodInDays: __expectString(output.LookbackPeriodInDays),
        PaymentOption: __expectString(output.PaymentOption),
        SavingsPlansPurchaseRecommendationDetails: output.SavingsPlansPurchaseRecommendationDetails != null
            ? deserializeAws_json1_1SavingsPlansPurchaseRecommendationDetailList(output.SavingsPlansPurchaseRecommendationDetails, context)
            : undefined,
        SavingsPlansPurchaseRecommendationSummary: output.SavingsPlansPurchaseRecommendationSummary != null
            ? deserializeAws_json1_1SavingsPlansPurchaseRecommendationSummary(output.SavingsPlansPurchaseRecommendationSummary, context)
            : undefined,
        SavingsPlansType: __expectString(output.SavingsPlansType),
        TermInYears: __expectString(output.TermInYears),
    };
};
const deserializeAws_json1_1SavingsPlansPurchaseRecommendationDetail = (output, context) => {
    return {
        AccountId: __expectString(output.AccountId),
        CurrencyCode: __expectString(output.CurrencyCode),
        CurrentAverageHourlyOnDemandSpend: __expectString(output.CurrentAverageHourlyOnDemandSpend),
        CurrentMaximumHourlyOnDemandSpend: __expectString(output.CurrentMaximumHourlyOnDemandSpend),
        CurrentMinimumHourlyOnDemandSpend: __expectString(output.CurrentMinimumHourlyOnDemandSpend),
        EstimatedAverageUtilization: __expectString(output.EstimatedAverageUtilization),
        EstimatedMonthlySavingsAmount: __expectString(output.EstimatedMonthlySavingsAmount),
        EstimatedOnDemandCost: __expectString(output.EstimatedOnDemandCost),
        EstimatedOnDemandCostWithCurrentCommitment: __expectString(output.EstimatedOnDemandCostWithCurrentCommitment),
        EstimatedROI: __expectString(output.EstimatedROI),
        EstimatedSPCost: __expectString(output.EstimatedSPCost),
        EstimatedSavingsAmount: __expectString(output.EstimatedSavingsAmount),
        EstimatedSavingsPercentage: __expectString(output.EstimatedSavingsPercentage),
        HourlyCommitmentToPurchase: __expectString(output.HourlyCommitmentToPurchase),
        SavingsPlansDetails: output.SavingsPlansDetails != null
            ? deserializeAws_json1_1SavingsPlansDetails(output.SavingsPlansDetails, context)
            : undefined,
        UpfrontCost: __expectString(output.UpfrontCost),
    };
};
const deserializeAws_json1_1SavingsPlansPurchaseRecommendationDetailList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1SavingsPlansPurchaseRecommendationDetail(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1SavingsPlansPurchaseRecommendationMetadata = (output, context) => {
    return {
        AdditionalMetadata: __expectString(output.AdditionalMetadata),
        GenerationTimestamp: __expectString(output.GenerationTimestamp),
        RecommendationId: __expectString(output.RecommendationId),
    };
};
const deserializeAws_json1_1SavingsPlansPurchaseRecommendationSummary = (output, context) => {
    return {
        CurrencyCode: __expectString(output.CurrencyCode),
        CurrentOnDemandSpend: __expectString(output.CurrentOnDemandSpend),
        DailyCommitmentToPurchase: __expectString(output.DailyCommitmentToPurchase),
        EstimatedMonthlySavingsAmount: __expectString(output.EstimatedMonthlySavingsAmount),
        EstimatedOnDemandCostWithCurrentCommitment: __expectString(output.EstimatedOnDemandCostWithCurrentCommitment),
        EstimatedROI: __expectString(output.EstimatedROI),
        EstimatedSavingsAmount: __expectString(output.EstimatedSavingsAmount),
        EstimatedSavingsPercentage: __expectString(output.EstimatedSavingsPercentage),
        EstimatedTotalCost: __expectString(output.EstimatedTotalCost),
        HourlyCommitmentToPurchase: __expectString(output.HourlyCommitmentToPurchase),
        TotalRecommendationCount: __expectString(output.TotalRecommendationCount),
    };
};
const deserializeAws_json1_1SavingsPlansSavings = (output, context) => {
    return {
        NetSavings: __expectString(output.NetSavings),
        OnDemandCostEquivalent: __expectString(output.OnDemandCostEquivalent),
    };
};
const deserializeAws_json1_1SavingsPlansUtilization = (output, context) => {
    return {
        TotalCommitment: __expectString(output.TotalCommitment),
        UnusedCommitment: __expectString(output.UnusedCommitment),
        UsedCommitment: __expectString(output.UsedCommitment),
        UtilizationPercentage: __expectString(output.UtilizationPercentage),
    };
};
const deserializeAws_json1_1SavingsPlansUtilizationAggregates = (output, context) => {
    return {
        AmortizedCommitment: output.AmortizedCommitment != null
            ? deserializeAws_json1_1SavingsPlansAmortizedCommitment(output.AmortizedCommitment, context)
            : undefined,
        Savings: output.Savings != null ? deserializeAws_json1_1SavingsPlansSavings(output.Savings, context) : undefined,
        Utilization: output.Utilization != null
            ? deserializeAws_json1_1SavingsPlansUtilization(output.Utilization, context)
            : undefined,
    };
};
const deserializeAws_json1_1SavingsPlansUtilizationByTime = (output, context) => {
    return {
        AmortizedCommitment: output.AmortizedCommitment != null
            ? deserializeAws_json1_1SavingsPlansAmortizedCommitment(output.AmortizedCommitment, context)
            : undefined,
        Savings: output.Savings != null ? deserializeAws_json1_1SavingsPlansSavings(output.Savings, context) : undefined,
        TimePeriod: output.TimePeriod != null ? deserializeAws_json1_1DateInterval(output.TimePeriod, context) : undefined,
        Utilization: output.Utilization != null
            ? deserializeAws_json1_1SavingsPlansUtilization(output.Utilization, context)
            : undefined,
    };
};
const deserializeAws_json1_1SavingsPlansUtilizationDetail = (output, context) => {
    return {
        AmortizedCommitment: output.AmortizedCommitment != null
            ? deserializeAws_json1_1SavingsPlansAmortizedCommitment(output.AmortizedCommitment, context)
            : undefined,
        Attributes: output.Attributes != null ? deserializeAws_json1_1Attributes(output.Attributes, context) : undefined,
        Savings: output.Savings != null ? deserializeAws_json1_1SavingsPlansSavings(output.Savings, context) : undefined,
        SavingsPlanArn: __expectString(output.SavingsPlanArn),
        Utilization: output.Utilization != null
            ? deserializeAws_json1_1SavingsPlansUtilization(output.Utilization, context)
            : undefined,
    };
};
const deserializeAws_json1_1SavingsPlansUtilizationDetails = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1SavingsPlansUtilizationDetail(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1SavingsPlansUtilizationsByTime = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1SavingsPlansUtilizationByTime(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1ServiceQuotaExceededException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const deserializeAws_json1_1ServiceSpecification = (output, context) => {
    return {
        EC2Specification: output.EC2Specification != null
            ? deserializeAws_json1_1EC2Specification(output.EC2Specification, context)
            : undefined,
    };
};
const deserializeAws_json1_1StartSavingsPlansPurchaseRecommendationGenerationResponse = (output, context) => {
    return {
        EstimatedCompletionTime: __expectString(output.EstimatedCompletionTime),
        GenerationStartedTime: __expectString(output.GenerationStartedTime),
        RecommendationId: __expectString(output.RecommendationId),
    };
};
const deserializeAws_json1_1Subscriber = (output, context) => {
    return {
        Address: __expectString(output.Address),
        Status: __expectString(output.Status),
        Type: __expectString(output.Type),
    };
};
const deserializeAws_json1_1Subscribers = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1Subscriber(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1TagList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const deserializeAws_json1_1TagResourceResponse = (output, context) => {
    return {};
};
const deserializeAws_json1_1TagValues = (output, context) => {
    return {
        Key: __expectString(output.Key),
        MatchOptions: output.MatchOptions != null ? deserializeAws_json1_1MatchOptions(output.MatchOptions, context) : undefined,
        Values: output.Values != null ? deserializeAws_json1_1Values(output.Values, context) : undefined,
    };
};
const deserializeAws_json1_1TagValuesList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1TagValues(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1TargetInstance = (output, context) => {
    return {
        CurrencyCode: __expectString(output.CurrencyCode),
        DefaultTargetInstance: __expectBoolean(output.DefaultTargetInstance),
        EstimatedMonthlyCost: __expectString(output.EstimatedMonthlyCost),
        EstimatedMonthlySavings: __expectString(output.EstimatedMonthlySavings),
        ExpectedResourceUtilization: output.ExpectedResourceUtilization != null
            ? deserializeAws_json1_1ResourceUtilization(output.ExpectedResourceUtilization, context)
            : undefined,
        PlatformDifferences: output.PlatformDifferences != null
            ? deserializeAws_json1_1PlatformDifferences(output.PlatformDifferences, context)
            : undefined,
        ResourceDetails: output.ResourceDetails != null
            ? deserializeAws_json1_1ResourceDetails(output.ResourceDetails, context)
            : undefined,
    };
};
const deserializeAws_json1_1TargetInstancesList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1TargetInstance(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1TerminateRecommendationDetail = (output, context) => {
    return {
        CurrencyCode: __expectString(output.CurrencyCode),
        EstimatedMonthlySavings: __expectString(output.EstimatedMonthlySavings),
    };
};
const deserializeAws_json1_1TooManyTagsException = (output, context) => {
    return {
        Message: __expectString(output.Message),
        ResourceName: __expectString(output.ResourceName),
    };
};
const deserializeAws_json1_1UnknownMonitorException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const deserializeAws_json1_1UnknownSubscriptionException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const deserializeAws_json1_1UnresolvableUsageUnitException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const deserializeAws_json1_1UntagResourceResponse = (output, context) => {
    return {};
};
const deserializeAws_json1_1UpdateAnomalyMonitorResponse = (output, context) => {
    return {
        MonitorArn: __expectString(output.MonitorArn),
    };
};
const deserializeAws_json1_1UpdateAnomalySubscriptionResponse = (output, context) => {
    return {
        SubscriptionArn: __expectString(output.SubscriptionArn),
    };
};
const deserializeAws_json1_1UpdateCostAllocationTagsStatusError = (output, context) => {
    return {
        Code: __expectString(output.Code),
        Message: __expectString(output.Message),
        TagKey: __expectString(output.TagKey),
    };
};
const deserializeAws_json1_1UpdateCostAllocationTagsStatusErrors = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1UpdateCostAllocationTagsStatusError(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1UpdateCostAllocationTagsStatusResponse = (output, context) => {
    return {
        Errors: output.Errors != null
            ? deserializeAws_json1_1UpdateCostAllocationTagsStatusErrors(output.Errors, context)
            : undefined,
    };
};
const deserializeAws_json1_1UpdateCostCategoryDefinitionResponse = (output, context) => {
    return {
        CostCategoryArn: __expectString(output.CostCategoryArn),
        EffectiveStart: __expectString(output.EffectiveStart),
    };
};
const deserializeAws_json1_1UtilizationByTime = (output, context) => {
    return {
        Groups: output.Groups != null ? deserializeAws_json1_1ReservationUtilizationGroups(output.Groups, context) : undefined,
        TimePeriod: output.TimePeriod != null ? deserializeAws_json1_1DateInterval(output.TimePeriod, context) : undefined,
        Total: output.Total != null ? deserializeAws_json1_1ReservationAggregates(output.Total, context) : undefined,
    };
};
const deserializeAws_json1_1UtilizationsByTime = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1UtilizationByTime(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1Values = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const deserializeMetadata = (output) => ({
    httpStatusCode: output.statusCode,
    requestId: output.headers["x-amzn-requestid"] ?? output.headers["x-amzn-request-id"] ?? output.headers["x-amz-request-id"],
    extendedRequestId: output.headers["x-amz-id-2"],
    cfId: output.headers["x-amz-cf-id"],
});
const collectBody = (streamBody = new Uint8Array(), context) => {
    if (streamBody instanceof Uint8Array) {
        return Promise.resolve(streamBody);
    }
    return context.streamCollector(streamBody) || Promise.resolve(new Uint8Array());
};
const collectBodyString = (streamBody, context) => collectBody(streamBody, context).then((body) => context.utf8Encoder(body));
const buildHttpRpcRequest = async (context, headers, path, resolvedHostname, body) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const contents = {
        protocol,
        hostname,
        port,
        method: "POST",
        path: basePath.endsWith("/") ? basePath.slice(0, -1) + path : basePath + path,
        headers,
    };
    if (resolvedHostname !== undefined) {
        contents.hostname = resolvedHostname;
    }
    if (body !== undefined) {
        contents.body = body;
    }
    return new __HttpRequest(contents);
};
const parseBody = (streamBody, context) => collectBodyString(streamBody, context).then((encoded) => {
    if (encoded.length) {
        return JSON.parse(encoded);
    }
    return {};
});
const parseErrorBody = async (errorBody, context) => {
    const value = await parseBody(errorBody, context);
    value.message = value.message ?? value.Message;
    return value;
};
const loadRestJsonErrorCode = (output, data) => {
    const findKey = (object, key) => Object.keys(object).find((k) => k.toLowerCase() === key.toLowerCase());
    const sanitizeErrorCode = (rawValue) => {
        let cleanValue = rawValue;
        if (typeof cleanValue === "number") {
            cleanValue = cleanValue.toString();
        }
        if (cleanValue.indexOf(",") >= 0) {
            cleanValue = cleanValue.split(",")[0];
        }
        if (cleanValue.indexOf(":") >= 0) {
            cleanValue = cleanValue.split(":")[0];
        }
        if (cleanValue.indexOf("#") >= 0) {
            cleanValue = cleanValue.split("#")[1];
        }
        return cleanValue;
    };
    const headerKey = findKey(output.headers, "x-amzn-errortype");
    if (headerKey !== undefined) {
        return sanitizeErrorCode(output.headers[headerKey]);
    }
    if (data.code !== undefined) {
        return sanitizeErrorCode(data.code);
    }
    if (data["__type"] !== undefined) {
        return sanitizeErrorCode(data["__type"]);
    }
};
