import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CostExplorerClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CostExplorerClient";
import { GetTagsRequest, GetTagsResponse } from "../models/models_0";
export interface GetTagsCommandInput extends GetTagsRequest {}
export interface GetTagsCommandOutput
  extends GetTagsResponse,
    __MetadataBearer {}
export declare class GetTagsCommand extends $Command<
  GetTagsCommandInput,
  GetTagsCommandOutput,
  CostExplorerClientResolvedConfig
> {
  readonly input: GetTagsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: GetTagsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CostExplorerClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<GetTagsCommandInput, GetTagsCommandOutput>;
  private serialize;
  private deserialize;
}
